Const GameName = "Energie Particle"
#Include "Energie Particle.bi"

Do
	WiederHole = 0
	
	Config = LoadXML ( "Config.epc" )
	
	If Config.ItemS ( "LogFile" ) = "" Then End
	
	InitLog ( Config.ItemS ( "LogFile" ) )
	WriteLog ( "======== Start "+GameName+" ========" )
	Screen_Width = Config.ItemI ( "Screen[1].Width" )
	Screen_Hight = Config.ItemI ( "Screen[1].Hight" )
	Screen_Flag = &H02 Or &H04
	If Config.ItemI ( "Screen[1].FullScreen" ) Then Screen_Flag Or= &H01
	
	ScreenRes Screen_Width, Screen_Hight, 32, 1, Screen_Flag
	WindowTitle ( GameName )
	
	INIT_GL ()
	
	MUSIC.Init ( Config.ItemS("SoundFont") )
	
	Blur.Compile ( Config.ItemS ( "ShaderFile" ) + "Blur" )
	TextBlur.Compile ( Config.ItemS ( "ShaderFile" ) + "TextBlur" )
	Schweif.Compile ( Config.ItemS ( "ShaderFile" ) + "Schweif" )
	
	TextFBOSize = IIf(Screen_Width>Screen_Hight,Screen_Width,Screen_Hight)
	TextFBOSize = Log(TextFBOSize)/Log(2)
	If TextFBOSize <> Int(TextFBOSize) Then TextFBOSize = Int(TextFBOSize+1)
	TextFBOSize = 2^TextFBOSize
	
	TextFBO.Create(TextFBOSize,TextFBOSize)
	TextFBO.NewTexture()
	TextFBO.NewTexture()
	TextFBO.UnBind()
	
	LoadTools ()
	
	If ErrorDetected () Then
		guitmExit ()
		WriteLog ( "========= End Auditori =========" )
		End
	EndIf
	
	glViewport ( 0, 0, Screen_Width, Screen_Hight )
	glMatrixMode ( GL_PROJECTION )
	glLoadIdentity ()
	glOrtho ( 0, Screen_Width, 0, Screen_Hight, -1, 1 )
	glMatrixMode ( GL_MODELVIEW )
	glLoadIdentity ()
	
	MainMenue ()
	
	MUSIC.Quit ()
	
	DestroyTools ()
	
	TextBlur.Destroy()
	Blur.Destroy()
	TextFBO.Destroy()
	guitmExit ()
	WriteLog ( "========= End "+GameName+" =========" )
	
Loop While WiederHole
