Declare Function Main Alias "Main" ( ByVal As Integer, ByVal As Integer, ByVal As Integer, ByVal As Integer ) As Integer

#Define TOOL_DESTROY &H00
#Define TOOL_INIT &H01
#Define TOOL_UPDATE &H02
#Define TOOL_RESET &H03
#Define TOOL_ADD &H04
#Define TOOL_SET &H05
#Define TOOL_GET &H06
#Define TOOL_PAINT_STATICS &H07
#Define TOOL_PAINT_ENABLED &H08
#Define TOOL_PAINT_SELECTS &H09
#Define TOOL_PAINT_LIGHT &H0A

#Define TOOL_MOUSEOVER_REMOVE &H01
#Define TOOL_MOUSEOVER_RESIZE &H02

#Define FALSE &H00
#Define TRUE Not FALSE
#Define NULL &H00

Type PARTICLE
	PosiX As Single
	PosiY As Single
	PosiXA As Single
	PosiYA As Single
	VectorX As Single
	VectorY As Single
	Alter As Single
	ColorR As Single
	ColorG As Single
	ColorB As Single
	TimeUderSpeedLimit As Single
	NoVerschub As Integer
	Next As PARTICLE Ptr
End Type

Type RECT
	Left As Single
	Right As Single
	Top As Single
	Bottom As Single
End Type

Type FRAMEMOUSE
	Declare Sub Update ()
	Frame As RECT
	X As Single
	Y As Single
	W As Integer
	B As Integer
	XA As Single
	YA As Single
	WA As Integer
	BA As Integer
	Dis As Any Ptr
	Over As Any Ptr
	entf As Single
	relptr As Integer Ptr
End Type

Type MAIN_TOOL
	posiX As Integer
	posiY As Integer
	radius As Integer
	grad As Integer
	light As UInteger
	r As Single
	g As Single
	b As Single
	transp As Single
	count As Single Ptr
	whatOver As Integer
	image As UInteger
End Type

Type ToolPaintSub As Sub ( ByVal As MAIN_TOOL Ptr, ByVal As FRAMEMOUSE Ptr )

Sub MouseOverPosi ( ByVal m As FRAMEMOUSE Ptr, ByVal x As Integer, ByVal y As Integer, ByVal r As Integer, ByVal relptr As Integer Ptr, ByVal id As Any Ptr )
	Dim Ent As Integer
	If m->Dis Then Exit Sub
	Ent = (M->X-x)^2+(M->Y-y)^2
	*relptr = 0
	If Ent<32*32 Then
		If m->entf <> -1 Then Exit Sub
		m->Over = id
		m->relptr = relptr
		m->entf = 0
		*relptr = TOOL_MOUSEOVER_REMOVE
	ElseIf Ent>=(r-5)^2 And Ent<(r+5)^2 Then
		If m->entf <> -1 Then Exit Sub
		m->Over = id
		m->relptr = relptr
		m->entf = 0
		*relptr = TOOL_MOUSEOVER_RESIZE
	ElseIf Ent<(r-5)^2 Then
		If m->Over <> 0 And m->Over <> id Then Exit Sub
		m->Over = id
		m->relptr = relptr
		m->entf = -1
		*relptr = TOOL_MOUSEOVER_RESIZE
	EndIf
End Sub
