'*******************************************************************************
'
' COUPS POSSIBLES
'
'*******************************************************************************

declare sub CalculPossibles (oc()  as byte,_
                             tr    as byte,_
                             pri() as ubyte,_
                             sec() as ubyte,_
                             pass  as string,_
                       byref liste as string,_
                       byref nbcps as ubyte)
                       
declare sub CalculPossiblesCourt (oc()  as byte,_
                                  tr    as byte,_
                            byref liste as string,_
                            byref nbcps as ubyte)
                    
'*******************************************************************************

sub CalculPossibles (oc()  as byte,_
                     tr    as byte,_
                     pri() as ubyte,_
                     sec() as ubyte,_
                     pass  as string,_
               byref liste as string,_
               byref nbcps as ubyte)
               
  dim as byte x1, y1, x2, y2
  dim as ubyte E
  dim as string lst=""
  
  type TPosition
    as byte valeur (1 to 8, 1 to 8)
  end type
  dim as TPosition actuelle, fictive
  
  for x1=1 to 8
    for y1=1 to 8
      
      actuelle.valeur(x1,y1)=oc(x1,y1)
      
    next y1
  next x1
  
  for x1=1 to 8
    for y1=1 to 8
      
      if not (sgn(oc(x1,y1))=tr) then continue for
      
      for x2=1 to 8
        for y2=1 to 8
          
          if sgn(oc(x2,y2))=tr then continue for
          
          if MouvementNaturel(x1,y1,x2,y2,oc())=Vrai then
            
            if (abs(oc(x1,y1))=Pion) andalso (x2<>x1) and (oc(x2,y2)=Vide) then
              if not (NomCarreau(x2,y2)=pass) then continue for
            end if
            
            if (abs(oc(x1,y1))=Roi) andalso (abs(x2-x1)=2) then
              
              if (tr=Blanc) then
                if (x2=3) then
                  if (pri(e1c1)=Faux) or (sec(e1c1)=Faux) then continue for
                else
                  if (pri(e1g1)=Faux) or (sec(e1g1)=Faux) then continue for
                end if
              else
                if (x2=3) then
                  if (pri(e8c8)=Faux) or (sec(e8c8)=Faux) then continue for
                else
                  if (pri(e8g8)=Faux) or (sec(e8g8)=Faux) then continue for
                end if
              end if
              
            end if
            
            fictive=actuelle
            fictive.valeur(x2,y2)=fictive.valeur(x1,y1)
            fictive.valeur(x1,y1)=Vide
            if abs(oc(x1,y1))=Pion andalso NomCarreau(x2,y2)=pass then
              fictive.valeur(x2,y2-tr)=Vide
            end if
            
            CalculEchecCourt(fictive.valeur(),tr,E)
            
            if E=Faux then lst+=NomCarreau(x1,y1)+NomCarreau(x2,y2)
            
          end if
          
        next y2
      next x2
    next y1
  next x1
  
  liste=lst
  nbcps=len(liste)\4
end sub' CalculPossibles

'*******************************************************************************

sub CalculPossiblesCourt (oc()  as byte,_
                          tr    as byte,_
                    byref liste as string,_
                    byref nbcps as ubyte)
  
  dim as byte x1, y1, x2, y2
  dim as ubyte E
  dim as string lst=""
  
  type TTablier
    as byte valeur (1 to 8, 1 to 8)
  end type
  dim as TTablier actuel, fictif
  
  for x1=1 to 8
    for y1=1 to 8
      actuel.valeur(x1,y1)=oc(x1,y1)
    next y1
  next x1
  
  for x1=1 to 8
    for y1=1 to 8
      if not (sgn(oc(x1,y1))=tr) then continue for
      for x2=1 to 8
        for y2=1 to 8
          if sgn(oc(x2,y2))=tr then continue for
          
          if MouvementNaturel(x1,y1,x2,y2,oc())=Vrai then
            if (abs(oc(x1,y1))=Pion) andalso (x2<>x1) then
              if (oc(x2,y2)=Vide) then continue for
            end if
            if (abs(oc(x1,y1))=Roi) andalso (abs(x2-x1)=2) then
              continue for
            end if
            
            fictif=actuel
            fictif.valeur(x2,y2)=fictif.valeur(x1,y1)
            fictif.valeur(x1,y1)=Vide
            
            CalculEchecCourt(fictif.valeur(),tr,E)
            
            if E=Faux then lst+=NomCarreau(x1,y1)+NomCarreau(x2,y2)
            
          end if
          
        next y2
      next x2
    next y1
  next x1
  
  liste=lst
  nbcps=len(liste)\4
end sub' CalculPossiblesCourt

'*******************************************************************************