#LibPath "lib"
#Include "inc\gamex.bi"

Using FB

ScreenRes 640,480,32 'Set Gfx mode before any Gfx classes

Dim As GxSOUND    Sound
Dim As GxBMPFONT  Font
Dim As GxINPUT    mkInput
Dim As GxSPRITES  Sprites
Dim As GxFPSCLOCK frameclock = GxFPSCLOCK(24)

   Dim As GxANIMATOR anim = GxANIMATOR(0,15,25)   'frames 0 to 15 @ 25fps
   
   Sprites.LoadSheet(0,"smurf1.bmp",128,128) 'tiles are 128x128
   Sprites.LoadSheet(1,"smurf2.bmp",128,128) 'tiles are 128x128
   
   Dim music1 As hSound Ptr
   
   If Sound.IsInitialized = 0 Then
      Print "Sound did not initialize!"
   Else
      music1 = Sound.LoadSound("smurf2.wav")
      Sound.PlaySound(music1,10,32)  
   EndIf
              
   Dim sheetnum   As Integer = 0
   Dim xloc       As Integer = 300
   Dim update     As Integer = 1
   Dim fmusic     As Integer = 1
   Do
   
      If frameclock.TickTime() Then 'process loop at specified FPS
         
         If mkInput.GetChar() = 32 Then 'Mute sound
            fmusic Xor= 1
            If fmusic Then
               Sound.PlaySound(music1,10,32)
            Else
               Sound.StopSound(music1)
            EndIf            
         EndIf
         
         If mkInput.TestKey(SC_LEFT) Then
            'Move sprite
            update = 1
            sheetnum = 1
            xloc-=5
            If xloc < -128 Then xloc = 640
         EndIf
         
         If mkInput.TestKey(SC_RIGHT) Then
            'Move sprite
            update = 1
            sheetnum = 0
            xloc+=5
            If xloc > 640 Then xloc = -128
         EndIf

         If update Then
            'Rendering
            ScreenLock
            
               Line (0,0)-(640,280),&hFF,BF 'Sky
               Line (0,280)-(640,480),&hFF00,BF 'Grass
               
               Font.DrawString(0,"Use Left/Right Arrows",5,5)
               Font.DrawString(0,"SPACE Toggles Music",5,30)
               Font.DrawString(0,"ESC to Exit",5,55)
               
               Sprites.SheetPut(0,sheetnum,xloc,176,anim.NextFrame()) 'Smurf
            
            ScreenUnLock
            update = 0
            
         EndIf
         
      EndIf

      Sleep 1
            
   Loop Until mkInput.TestKey(SC_ESCAPE) 'wait for any char to end

