'
' SDL Rendering Object 
'  -Verison 0.2 | by Vincent DeCampo, 2010 
'
'  Updated 2010-11-17
'     New Functions Added
'     - KeyCheck (Similar to MultiKey)
'     - Mouse (Similar to GetMouse)
'
#Print "SCREEN ENABLED"
   
Namespace GAMEX_SCREEN
   
#Include Once "fbgfx.bi"
#Include Once "SDL\SDL.bi"
#Include Once "crt.bi"

#Ifndef SDL_BORDERLESS 
   #Define SDL_BORDERLESS  32
#EndIf

Type GxSCREEN
   Declare Constructor(dx As Integer = 640, dy As Integer = 480, _
                       bpp As Integer = 32, flags As Integer = 0, _
                       winpos As Integer = 0)
   Declare Destructor
   '
   Declare Function   GetSurface() As FB.IMAGE Ptr
   Declare Function   Event() As SDL_Event
   Declare Function   KeyPress() As SDLKey
   Declare Function   KeyCheck(scancode As Integer) As Integer
   Declare Sub        WindowTitle(title As String)
   Declare Sub        Mouse(ByRef x As Integer,ByRef y As Integer,ByRef button As Integer) 
   Declare Sub        EventPump()       
   Declare Sub        ScreenLock()
   Declare Sub        ScreenUnLock()
   '
   As UInteger        InitError
   As UInteger        ModeError   
   '
   As Integer         thread_running, exit_thread
   As Any Ptr         mtx,pixel_ptr
   As Integer         scr_width, scr_height, scr_bpp
   As FB.IMAGE Ptr    draw_surface 
	As SDL_Surface Ptr video
	As SDL_Event       events
	
End Type

#Ifdef MAKELIB
   #Include "GxSCREEN.bas"
#EndIf

End Namespace

Using GAMEX_SCREEN

