#Include Once "fbgfx.bi"
#Include Once "png.bi"
#Include Once "file.bi"

#Print "SPRITES ENABLED"

Namespace GAMEX_SPRITES

#Macro DeAlloc(x)
   DeAllocate(x)
   x=0   
#EndMacro

#Define MAX_SPRITES		 200
#Define MaxSheetIdx      10

Type SPRITESHEET_STRUCT
   As Integer        Cols
   As Integer        Rows
   As Integer        SpriteWidth
   As Integer        SpriteHeight
   As Any Ptr        SpriteSheet	
   As Integer        SheetWidth
   As Integer        SheetHeight   
End Type

Type GxSPRITES
   
	Declare Constructor ()
	Declare Destructor  ()
	
	Declare Function LoadSprite (index As Integer, filename As String) As Any Ptr
	Declare Function GetImage 	 (index As Integer) As Any Ptr

   Declare Function LoadSheet  (index As Integer, filename As String, TileDx As Integer, TileDy As Integer) As Integer
   Declare Sub      SheetPut   (dst As Any Ptr, index As Integer, x As Integer, y As Integer, fnum As Integer, trans As Integer = 1) 
   Declare Function SheetImage (index As Integer) As Any Ptr

   Declare Function LoadBitmap (filename As String) As Any Ptr
   Declare Function LoadPNG    (filename As String) As Any Ptr
   
   As SPRITESHEET_STRUCT   Sheet(MaxSheetIdx)
   '
Private:
   
   '
   As Any Ptr        imgLastPut(MaxSheetIdx)
	As Integer Ptr	   imgStore
	As Integer 		   imgCount
	'
End Type

#Ifdef MAKELIB
   #Include "GxSPRITES.bas"
#EndIf

End Namespace

Using GAMEX_SPRITES
