'Action.bas - Game207 GUI control action
'Ryan Kely (codeFoil) 2012

'==========================================================================|

#IfDef  DEBUG_ACTION
#Define  DEBUG
#EndIf
#Include  once "Debug.bi"

#Include  once "GUI\Action.bi"

'==========================================================================|

public _
Sub  Action.Set(byval newId as Integer     ,_
                byval listener   as any ptr,_
                byval routinePtr as any ptr)

    DASSERT(routinePtr <> NULL, "Null pointer passed as Callback!")

    id = newId
    eventListener = listener
    callBack = Cast(Event_CallBack, routinePtr )

End  sub

public _
Function Action.Fire() as Boolean

    function = FALSE
    If callBack <> NULL Then
        function = callBack(eventListener, id )
    End  if

End  function