'Static_Image.bas - Game207 static image
'Ryan Kelly (codeFoil) 2012

'==========================================================================|
#IfDef DEBUG_STATIC_IMAGE
#Define DEBUG
#EndIf
#Include  once "Debug.bi"

#Include  once "GUI\Static_Image.bi"

'==========================================================================|

public _
Constructor  Static_Image(byval iX as Integer                          ,_
                          byval iY as Integer                          ,_
                          byval iW as Integer                          ,_
                          byval iH as Integer                          ,_
                          byval fC as Colour_Value = COLOUR_TRANSPARENT )

    box.Set(iX, iY, iW, iH )

    image = ImageCreate(iW, iH, fC )

    If image = NULL Then
        DPRINT("Image creation failed!")
        errorFlag = TRUE
    End if

End  constructor

public _
Destructor  Static_Image()

    If image <> NULL Then
        ImageDestroy image
    End  if
End  destructor

'--------------------------------------------------------------------------|

public _ 
Sub  Static_Image.Fill(byval fillRoutine as Image_Crafter )

    DASSERT(fillRoutine <> NULL, "Null pointer!")
    fillRoutine(image)

End  sub

'--------------------------------------------------------------------------|

public _
Sub  Static_Image.Draw(byval dest as Image_Buffer )

    DASSERT(dest <> NULL, "Null pointer!" )
    Dim  as Integer x, y
    box.GetFirst(x, y)
    Put  dest, (x,y), image, ALPHA, transparency

End  sub
