'Slot_Selector.bi - Game207 game board slot selection control
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

'Included by GUI.bi
'Include order must be preserved

#IfnDef  GAME207_GUI
#Include  once "Common.bi"
#Include  once "Board_State.bi"
#Include  once "Screen_Event.bi"
#Include  once "GUI\Action.bi"
#Include  once "Bounding_Box.bi"
#EndIf

'===SLOT=SELECTOR==========================================================|

Type  Slot_Selector


  Public:

    Declare  constructor()
    Declare  destructor()

    Declare  sub ConnectState(byval newState as Board_State ptr )

    Declare  sub SetColor(byval newC as Colour_Value)

    Declare  sub Draw(byval dest as Image_Buffer)

    Declare  function Enable()        as Boolean
    Declare  function ShimmedEnable() as Boolean
    Declare  function Disable()       as Boolean
    Declare  property isEnabled()     as Boolean

    Declare  function Show()      as Boolean
    Declare  function Hide()      as Boolean
    Declare  property isVisible() as Boolean

    Declare  property selectedSlot(byval newSlot as Integer)
    Declare  property selectedSlot() as Integer

    as  Bounding_Box box
    as  Action      actionClick

    as  Boolean errorFlag

  Private:
    as  Board_State ptr boardState
    
    as  Image_Buffer  slotHighlight
    as  Integer       currentSlot = 0
    as  Boolean       enabledFlag = FALSE,_
                      visibleFlag = FALSE,_
                      mouseIsMine

  Public:
    Declare static function HandleEvent(byval this as Slot_Selector ptr ,_
                                        byref event as Screen_Event      )_
                                        as Boolean

  Private:
    Declare  function MouseMove(byval mouseX as Integer,_
                                byval mouseY as Integer ) as Boolean    

End  type
