'Sprite.bi - Game207 Animated Sprite
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

'Included by GUI.bi
'Include order must be preserved.

#IfnDef GAME207_GUI
#Include  once "Common.bi"
#Include  once "Action.bi"
#Include  once "Bounding_Box.bi"
#EndIf

'===SRITE==================================================================|

Type  Sprite

  Public:

    Declare  constructor(byval initX as Integer,_
                         byval initY as Integer,_
                         byval initH as Integer,_
                         byval initW as Integer,_
                         byval numF  as Integer )

    Declare  destructor()

    Declare sub SetImage(byval newImg as Image_Buffer,_
                         byval fIndex as Integer      )


    Declare  sub Draw(byval dest as Image_Buffer               ,_
                      byval drawOnBackground as Boolean = FALSE )

    Declare  sub BeginAnimation(byval fReset      as Boolean = TRUE ,_
                                byval fRestart    as Boolean = FALSE,_
                                byval fBackground as Boolean = FALSE )

    Declare  sub Target(byval tX          as Integer         ,_
                        byval tY          as Integer         ,_
                        byval nSteps      as Integer         ,_
                        byval fBackground as Boolean = FALSE  )


    Declare  sub BeginStrobe(byval aDelta as Integer = 1  ,_
                             byval aMin   as Integer = 1  ,_
                             byval aMax   as Integer = 255 )

    Declare  sub BeginPulse (byval aDelta as Integer = 1  ,_
                             byval aMin   as Integer = 1  ,_
                             byval aMax   as Integer = 255 )
   

    Declare  function Show()      as Boolean
    Declare  function Hide()      as Boolean
    Declare  property isVisible() as Boolean

    as  Bounding_Box box
    as  Action targetReached
    as  Boolean errorFlag
    
  Private:  
    as  Boolean animateFlag   ,_
                visibleFlag   ,_
                backGroundFlag,_
                resetFlag     ,_
                restartFlag   ,_
                pulseFlag     ,_
                strobeFlag    ,_
                movingFlag 

    as  Integer frameCount  ,_
                currentFrame,_
                currentAlpha,_
                maxAlpha    ,_
                minAlpha    ,_
                alphaDelta  
    as  Double  curX        ,_
                curY        ,_
                targetX     ,_
                targetY     ,_
                deltaX      ,_
                deltaY   

    as  Image_Buffer ptr frame
    as  Boolean      ptr frameIsMine
                

End  type

'==========================================================================|

