'Screen_Event.bi ' Game_207 Screen Event wrapper
'Ryan Kelly (codeFoil) 2012

'==========================================================================|
'ScreenControl constants
#Define SC_GET_DESKTOP_SIZE     (  3)
#Define SC_SET_WINDOW_POS       (100)
#Define SC_GET_WINDOW_POS       (  0)
#Define SC_SET_ALPHA_PRIMITIVES (104)

'==========================================================================|

Enum  Event_Code
    NULL_EVENT = 0
    KEY_PRESS   
    KEY_RELEASE
    KEY_REPEAT
    MOUSE_MOVE
    MOUSE_BUTTON_PRESS
    MOUSE_BUTTON_RELEASE
    MOUSE_BUTTON_DCLICK
    MOUSE_BUTTON_WHEEL
    MOUSE_BUTTON_ENTER
    MOUSE_EXIT
    WINDOW_FOCUS
    WINDOW_LOSE_FOCUS
    WINDOW_CLOSE    
End  enum

'==========================================================================|

#Define  MOUSE_BUTTON_LEFT   &h00000001
#Define  MOUSE_BUTTON_RIGHT  &h00000002
#Define  MOUSE_BUTTON_MIDDLE &h00000004


'==========================================================================|

Type  Screen_Event Field = 1

    as  Event_Code code
    Union

        Type
            as  Integer scanCode
            as  Integer asciiCode
        End  type

        Type
            as  Integer mouseX
            as  Integer mouseY
            as  Integer mouseDX
            as  Integer mouseDY
        End type

        as  Integer mouseButton
        as  Integer mouseWheel

    End  union

End  Type

