Const GameName = "Energie Particle Editor"
#Include "Energie Particle Editor.bi"

Config = LoadXML ( "Config.epc" )

If Config.ItemS ( "LogFile" ) = "" Then End

InitLog ( Config.ItemS ( "LogFile" ) )
WriteLog ( "======== Start "+GameName+" ========" )
Screen_Width = Config.ItemI ( "Screen[1].Width" )
Screen_Hight = Config.ItemI ( "Screen[1].Hight" )

Sub OtherSetting ( ByVal S As String )
	Dim p As String
	p = Str(GetTool(AkTool.Na,AkTool.ID,s))
	SST = -1
	SetDlgItemText(TOOLWIN,TXT_SETTINGLSSTATE,strptr(p))
	SST = 0
End Sub

Sub UpdateSetting ()
	Dim A As Long
	Dim p As String
	SendMessage(SETINGSCBO,CB_RESETCONTENT,0,0)
	For i As Integer = 1 To GetTool(AkTool.Na,0,"numparam")
		p = *Cast(ZString Ptr,GetTool(AkTool.Na,0,"param"+Str(i)))
		A = SendMessage(SETINGSCBO,CB_ADDSTRING,0,Cast(LPARAM,StrPtr(p)))
		SendMessage(SETINGSCBO,CB_SETITEMDATA,A,0)
		SendMessage(SETINGSCBO,CB_SETCURSEL,A,0)
	Next
	p = Str(GetTool(AkTool.Na,AkTool.ID,p))
	SST = -1
	SetDlgItemText(TOOLWIN,TXT_SETTINGLSSTATE,StrPtr(p))
	SST = 0
End Sub

Sub OtherTool ( ByVal S As String, ByVal I As Integer )
	Dim temp As TABELLENITEM Ptr
	If Level Then
		temp = Level->GetItem(S+"["+Str(I)+"]")
		If temp <> 0 Then
			Tool = temp->GetValTP()
		EndIf
	EndIf
	AkTool.Na = S
	AkTool.ID = i
	UpdateSetting ()
End Sub

Sub UpdateTool ()
	Dim A As Long
	Dim N As String
	Dim St As String
	Dim t As TOOL Ptr
	Dim num As Integer
	Dim temp As TABELLENITEM Ptr
	SendMessage(TOOLCBO,CB_RESETCONTENT,0,0)
	If Level Then
		t = __FirstTool__
		Do Until t = 0
			N = *Cast(ZString Ptr,T->Main(TOOL_GET,Cast(Integer,StrPtr("Name")),0,0))
			num = 0
			Do
				num += 1
				If Level->ExistItem(N+"["+Str(num)+"]") Then
					st = N+"["+Str(num)+"]"
					A = SendMessage(TOOLCBO,CB_ADDSTRING,0,Cast(LPARAM,strptr(st)))
					SendMessage(TOOLCBO,CB_SETITEMDATA,A,0)
					SendMessage(TOOLCBO,CB_SETCURSEL,A,0)
					temp = Level->GetItem(N+"["+Str(num)+"]")
					if temp Then
						Tool = temp->GetValTP()
					EndIf
					AkTool.Na = N
					AkTool.ID = num
				Else
					Exit Do
				EndIf
			Loop
			t = t->next
		Loop
	EndIf
	UpdateSetting ()
End Sub

Sub OtherLevel ( ByVal S As String )
	Dim temp As TABELLENITEM Ptr
	temp = Game.GetItem(S+"[1]")
	If temp <> 0 Then
		Level = temp->GetValTP()
	EndIf
	SetDlgItemText(TOOLWIN,TXT_LEVELNAME,@S)
	If Level Then
		SetDlgItemText(TOOLWIN,TXT_NEXTLEVEL,Level->ItemS("NextLevel"))
		SetDlgItemText(TOOLWIN,TXT_MUSICFILE,Level->ItemS("MusicFile"))
	EndIf
	ResetTools ()
	If Level Then SetLevelTool(Level)
	UpdateTool ()
End Sub

Sub UpdateLevel ()
	Dim num As Integer
	Dim it As TABELLENITEM Ptr
	Dim n As String
	Dim A As Long
	SendMessage(LEVELCBO,CB_RESETCONTENT,0,0)
	num = 0
	Do
		num += 1
		it = Game.GetItem(num)
		If it = 0 Then Exit Do
		If it->GetType = ITEM_TABELLE Then
			N = Mid(it->GetName(),1,Len(it->GetName())-3)
			A = SendMessage(LEVELCBO,CB_ADDSTRING,0,Cast(LPARAM,strptr(N)))
			SendMessage(LEVELCBO,CB_SETITEMDATA,A,0)
			SendMessage(LEVELCBO,CB_SETCURSEL,A,0)
			Level = it->GetValTP()
		EndIf
	Loop
	ResetTools ()
	If Level Then SetLevelTool(Level)
	SetDlgItemText(TOOLWIN,TXT_LEVELNAME,strptr(N))
	SetDlgItemText(TOOLWIN,TXT_STARTLEVEL,Game.itemS("StartLevel"))
	If Level Then
		SetDlgItemText(TOOLWIN,TXT_NEXTLEVEL,Level->ItemS("NextLevel"))
		SetDlgItemText(TOOLWIN,TXT_MUSICFILE,Level->ItemS("MusicFile"))
	EndIf
	UpdateTool ()
End Sub

Function MusicFile_WIN_PROC(ByVal hWin As HWND, ByVal uMsg as UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	Select Case uMsg
		Case WM_INITDIALOG
			Dim As String s
			s=Dir(ExePath+"/"+Config.ItemS("MusicFile")+"/*.mid")
			Do Until s=""
				SendMessage(GetDlgItem(hWin,MUSICFILE_LIST),LB_ADDSTRING,FALSE,Cast(UInteger,StrPtr(s)))
				s=Dir()
			Loop
		Case WM_CLOSE
			EndDialog(hWin,0)
			
		Case WM_COMMAND
			Select Case LoWord(wParam)
				Case MUSICFILE_LIST
					If HiWord(wParam) = LBN_DBLCLK Then
						Dim A As Long
						Dim L As Long
						Dim s As String
						A = SendMessage(GetDlgItem(hWin,MUSICFILE_LIST),LB_GETCURSEL,FALSE,FALSE)
						L = SendMessage(GetDlgItem(hWin,MUSICFILE_LIST),LB_GETTEXTLEN,A,0)
						s = String(L," ")
						SendMessage(GetDlgItem(hWin,MUSICFILE_LIST),LB_GETTEXT,A,Cast(LPARAM,StrPtr(s)))
						SetDlgItemText(TOOLWIN,TXT_MUSICFILE,StrPtr(s))
						EndDialog(hWin,0)
					EndIf
					
			End Select
		Case else
			Return FALSE
			
	End Select
	Return TRUE

End Function

Function TOOL_WIN_PROC(ByVal hWin As HWND, ByVal uMsg as UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	Select Case uMsg
		Case WM_INITDIALOG
			Dim t As TOOL Ptr
			TOOLWIN = hwin
			TOOLLIST = GetDlgItem(hWin,TOOL_LIST)
			TOOLCBO = GetDlgItem(hWin,CBO_TOOL)
			LEVELCBO = GetDlgItem(hWin,CBO_LEVEL)
			SETINGSCBO = GetDlgItem(hWin,CBO_SETTINGS)
			t = __FirstTool__
			Do Until t = 0
				SendMessage(TOOLLIST,LB_ADDSTRING,FALSE,Cast(UInteger,T->Main(TOOL_GET,Cast(Integer,StrPtr("Name")),0,0)))
				t = t->Next
			Loop
			
		Case WM_CLOSE
			DestroyWindow(hWin)
			
		Case WM_COMMAND
			Select Case LoWord(wParam)
				Case BTN_ADDLEVEL
					Dim NewName As String = "New Level"
					Dim num As Integer
					Dim A As Long
					If Game.ExistItem(NewName+"[1]") Then
						num = 0
						Do
							num += 1
							If Game.ExistItem(NewName+Str(num)+"[1]")=0 Then Exit Do
						Loop
						NewName += Str(num)
					EndIf
					Game.ItemS(NewName+"[1].NextLevel") = ""
					A = SendMessage(LEVELCBO,CB_ADDSTRING,0,Cast(LPARAM,strptr(NewName)))
					SendMessage(LEVELCBO,CB_SETITEMDATA,A,0)
					SendMessage(LEVELCBO,CB_SETCURSEL,A,0)
					OtherLevel(NewName)
					
				Case BTN_DELETELEVEL
					Dim S As ZString*20
					Dim A As Long
					A = SendMessage(LEVELCBO,CB_GETCURSEL,0,0)
					If A = -1 Then Exit Select
					SendMessage(LEVELCBO,CB_GETLBTEXT,A,Cast(UInteger,@S))
					Game.DestroyItem(S+"[1]")
					SendMessage(LEVELCBO,CB_DELETESTRING,A,FALSE)
					If A > 0 Then
						A -= 1
					EndIf
					SendMessage(LEVELCBO,CB_SETCURSEL,A,0)
					A = SendMessage(LEVELCBO,CB_GETCURSEL,0,0)
					If A = -1 Then
						OtherLevel("")
					Else
						SendMessage(LEVELCBO,CB_GETLBTEXT,A,Cast(UInteger,@S))
						OtherLevel(S)
					EndIf
					
				Case CBO_LEVEL
					Dim A As Long
					Dim S As ZString*20
					A = SendMessage(LEVELCBO,CB_GETCURSEL,0,0)
					SendMessage(LEVELCBO,CB_GETLBTEXT,A,Cast(UInteger,@S))
					OtherLevel (S)
					
				Case TXT_LEVELNAME
					Dim S As ZString*20
					Dim S2 As ZString*20
					Dim ti As TABELLENITEM Ptr
					Dim A As Long
					GetDlgItemText(TOOLWIN,TXT_LEVELNAME,@S,SizeOf(S))
					If Game.ExistItem(S+"[1]") = 0 Then
						A = SendMessage(LEVELCBO,CB_GETCURSEL,0,0)
						SendMessage(LEVELCBO,CB_GETLBTEXT,A,Cast(UInteger,@S2))
						If S <> S2 Then
							ti = Game.GetItem(S2+"[1]")
							If ti <> 0 Then
								ti->SetName(S+"[1]")
								SendMessage(LEVELCBO,CB_DELETESTRING,A,FALSE)
								A = SendMessage(LEVELCBO,CB_INSERTSTRING,A,Cast(LPARAM,strptr(S)))
								SendMessage(LEVELCBO,CB_SETITEMDATA,A,0)
								SendMessage(LEVELCBO,CB_SETCURSEL,A,0)
							EndIf 
						EndIf	
					EndIf 
					
				Case TXT_NEXTLEVEL
					Dim S As ZString*20
					GetDlgItemText(TOOLWIN,TXT_NEXTLEVEL,@S,SizeOf(S))
					If Level Then Level->ItemS("NextLevel") = S
					
				Case TXT_MUSICFILE
					Dim S As ZString*256
					GetDlgItemText(TOOLWIN,TXT_MUSICFILE,@S,SizeOf(S))
					If Level Then 
						Level->ItemS("MusicFile") = S
						LevelMusic->load(ExePath+"/"+Config.ItemS("MusicFile")+S,TRUE)
						LevelMusic->play()
						For i As Integer = 0 To 15
							LevelMusic->setChannelVol(i,0)
							MusicVol(i) = 0
						Next
					EndIf
					
				Case BTN_SURCHMUSICFILE
					DialogBoxParam(hInstance,Cast(zstring ptr,MusicFile_WIN),hWin,@MusicFile_WIN_PROC,NULL)
					
				Case TXT_WIDTH
					Dim S As ZString*20
					GetDlgItemText(TOOLWIN,TXT_WIDTH,@S,SizeOf(S))
					Game.Item("width") = Val(S)
					
				Case TXT_HIGHT
					Dim S As ZString*20
					GetDlgItemText(TOOLWIN,TXT_HIGHT,@S,SizeOf(S))
					Game.Item("hight") = Val(S)
					
				Case TXT_STARTLEVEL
					Dim S As ZString*20
					GetDlgItemText(TOOLWIN,TXT_STARTLEVEL,@S,SizeOf(S))
					Game.ItemS("StartLevel") = S

				Case TXT_SETTINGLSSTATE
					Dim A As Long
					Dim S As ZString*20
					Dim S2 As ZString*20
					If tool <> 0 And SST = 0 Then 
						GetDlgItemText(TOOLWIN,TXT_SETTINGLSSTATE,@S,SizeOf(S))
						A = SendMessage(SETINGSCBO,CB_GETCURSEL,0,0)
						SendMessage(SETINGSCBO,CB_GETLBTEXT,A,Cast(UInteger,@S2))
						SetTool(AkTool.Na,AkTool.ID,S2,Val(S))
						Tool->ItemI(S2) = Val(S)
					EndIf
					
				Case BTN_ADDTOOL
					Dim A As Long
					Dim S As ZString*20
					Dim St As String
					Dim p As String
					Dim num As Integer
					A = SendMessage(TOOLLIST,LB_GETCURSEL,FALSE,FALSE)
					SendMessage(TOOLLIST,LB_GETTEXT,A,Cast(LPARAM,@S))
					If A <> -1 Then
						num = AddTool(S)
						St = S+"["+Str(num)+"]"
						A = SendMessage(TOOLCBO,CB_ADDSTRING,0,Cast(LPARAM,strptr(St)))
						SendMessage(TOOLCBO,CB_SETITEMDATA,A,0)
						SendMessage(TOOLCBO,CB_SETCURSEL,A,0)
					EndIf
					For i As Integer = 1 To GetTool(S,0,"numparam")
						p = *Cast(ZString Ptr,GetTool(S,0,"param"+Str(i)))
						If level Then Level->ItemI(St+"."+p) = GetTool(S,num,p)
					Next
					OtherTool (S,num)
					
				Case BTN_DELETETOOL
					Dim A As Long
					Dim S As ZString*20
					Dim Na As String
					Dim num As Integer
					Dim it As TABELLENITEM Ptr
					A = SendMessage(TOOLCBO,CB_GETCURSEL,0,0)
					SendMessage(TOOLCBO,CB_GETLBTEXT,A,Cast(UInteger,@S))
					For i As Integer = Len(S) To 1 Step -1
						If Mid(S,i,1) = "[" Then
							Na = Mid(S,1,i-1)
							num = Val(Mid(S,i+1))
							Exit For
						EndIf
					Next
					If Level Then
						Level->DestroyItem(S)
						Level->DestroyItem(Na)
						Do
							num += 1
							it = level->GetItem(Na+"["+Str(num)+"]")
							If it = 0 Then Exit Do
							it->SetName(Na+"["+Str(num-1)+"]")
						Loop
					EndIf
					
					A = SendMessage(LEVELCBO,CB_GETCURSEL,0,0)
					SendMessage(LEVELCBO,CB_GETLBTEXT,A,Cast(UInteger,@S))
					OtherLevel (S)
					
				Case CBO_TOOL
					Dim A As Long
					Dim S As ZString*20
					Dim SWC As String
					Dim ID As Integer
					A = SendMessage(TOOLCBO,CB_GETCURSEL,0,0)
					SendMessage(TOOLCBO,CB_GETLBTEXT,A,Cast(UInteger,@S))
					For i As Integer = 19 To 1 Step -1
						If Mid(S,i,1) = "[" Then
							SWC = Mid(S,1,i-1)
							ID = Val(Mid(S,i+1))
							Exit For 
						EndIf
					Next
					OtherTool (SWC,ID)
					
				Case CBO_SETTINGS
					Dim A As Long
					Dim S As ZString*20
					A = SendMessage(SETINGSCBO,CB_GETCURSEL,0,0)
					SendMessage(SETINGSCBO,CB_GETLBTEXT,A,Cast(UInteger,@S))
					OtherSetting (S)
					
			End Select
		Case Else
			Return FALSE
			
	End Select
	Return TRUE

End Function

Function MAIN_WIN_PROC(ByVal hWin As HWND, ByVal uMsg as UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	Dim WinRect As RECT
	Select Case uMsg
		Case WM_INITDIALOG
			Dim rect As RECT
			
			GLBOX = GetDlgItem (hWin,GL_BOX)
			GetClientRect (hwin,@WinRect)
			
			SendMessage (hWin, WM_SETICON, ICON_SMALL, Cast(LPARAM,LoadIcon(hInstance,MAKEINTRESOURCE(FB_PROGRAM_ICON))) )
			
			INIT_GL ()
			Blur.Compile ( Config.ItemS ( "ShaderFile" ) + "Blur" )
			Schweif.Compile ( Config.ItemS ( "ShaderFile" ) + "Schweif" )
			LoadTools ()
			glViewport ( 0, 0, Screen_Width, Screen_Hight )
			glMatrixMode ( GL_PROJECTION )
			glLoadIdentity ()
			glOrtho ( 0, Screen_Width, 0, Screen_Hight, -1, 1 )
			glMatrixMode ( GL_MODELVIEW )
			glLoadIdentity ()
			If ErrorDetected ()  Then SendMessage(hWin,WM_CLOSE,0,0)
			
			TOOLBOX = CreateDialogParam (hInstance,Cast(zstring ptr,TOOL_WIN),hwin,@TOOL_WIN_PROC,NULL)
			GetClientRect (TOOLBOX,@rect)
			MoveWindow (TOOLBOX,WinRect.right-Rect.right,0,Rect.right,WinRect.bottom,TRUE)
			MoveWindow (GLBOX,0,0,WinRect.right-Rect.right,WinRect.bottom,TRUE)
			
			MUSIC.Init( Config.ItemS("SoundFont") )
			LevelMusic = MUSIC.create()
			
			SetToolMusic(@MusicVol(0))
			
		Case WM_CLOSE
			
			If LevelMusic Then LevelMusic->destroy()
			MUSIC.Quit( )
			
			wglMakeCurrent (NULL, NULL)
			wglDeleteContext(GLRC)
			
			DestroyTools ()
			TextBlur.Destroy()
			Blur.Destroy()
			GameFBO.Destroy()
			ParticleFBO.Destroy()

			DestroyWindow(hWin)
			
		Case WM_SIZE
			Dim rect As RECT
			GetClientRect(hwin,@WinRect)
			GetClientRect(TOOLBOX,@Rect)
			MoveWindow(TOOLBOX,WinRect.right-Rect.right,0,Rect.right,WinRect.bottom,TRUE)
			MoveWindow(GLBOX,0,0,WinRect.right-Rect.right,WinRect.bottom,TRUE)
			
		Case WM_COMMAND
			Select Case LoWord(wParam)
				Case IDM_NEW
					Dim S As ZString*2="0"
					Game.Destroy()
					Game = TABELLE()
					Game.Item("version") = 2.0
					Game.Item("width") = 0
					Game.Item("hight") = 0
					SetDlgItemText(TOOLWIN,TXT_WIDTH,@S)
					SetDlgItemText(TOOLWIN,TXT_HIGHT,@S)
					UpdateLevel ()
				Case IDM_OPEN
					Dim N As String
					N = OpenFFile ( hWin, "Energie Particle Game (*.epg)" & szNULL & "*.epg" & szNULL, "Open File" )
					If N <> "" Then
						If InStr(N,".") = 0 Then N += ".epg"
						Game.Destroy()
						Game = TABELLE()
						Game = LoadXML(N)
						Dim S As String
						S = Game.ItemS("width")
						SetDlgItemText(TOOLWIN,TXT_WIDTH,StrPtr(S))
						S = Game.ItemS("hight")
						SetDlgItemText(TOOLWIN,TXT_HIGHT,StrPtr(S))
						UpdateLevel ()
					EndIf
				Case IDM_SAVE_AS
					Dim N As String
					N = SaveFFile ( hWin, "Energie Particle Game (*.epg)" & szNULL & "*.epg" & szNULL, "Save File" )
					If N <> "" Then
						If InStr(N,".") = 0 Then N += ".epg"
						SaveXML(N,Game)
					EndIf
				Case IDM_SAVE
					If LastFile = ExePath+"/Unnamed.epg" Then
						Dim N As String
						N = SaveFFile ( hWin, "Energie Particle Game (*.epg)" & szNULL & "*.epg" & szNULL, "Save File" )
						If N <> "" Then
							If InStr(N,".") = 0 Then N += ".epg"
							SaveXML(N,Game)
						EndIf
					Else
						If InStr(LastFile,".") = 0 Then LastFile += ".epg"
						SaveXML(LastFile,Game)
					EndIf
				Case IDM_EXIT
					SendMessage(hWin,WM_CLOSE,0,0)
			End Select
		Case else
			Return FALSE
			
	End Select
	Return TRUE

End Function

DialogBoxParam(hInstance,Cast(zstring ptr,MAIN_WIN),NULL,@MAIN_WIN_PROC,NULL)

WriteLog ( "========= End "+GameName+" =========" )
ExitProcess(0)
