#Define FB_PROGRAM_ICON 1
#define Main_WIN 1000
#define GL_BOX 1001
#define MAIN_WIN_MENU 10000
#define IDM_NEW 10001
#define IDM_OPEN 10002
#define IDM_SAVE 10003
#define IDM_SAVE_AS 10004
#define IDM_EXIT 10005
#define TOOL_WIN 1100
#define CBO_LEVEL 1101
#define BTN_ADDLEVEL 1102
#define BTN_DELETELEVEL 1103
#define TOOL_LIST 1104
#define BTN_ADDTOOL 1105
#define CBO_TOOL 1106
#define BTN_DELETETOOL 1107
#define CBO_SETTINGS 1108
#define TXT_SETTINGLSSTATE 1109
#define TXT_LEVELNAME 1110
#define TXT_NEXTLEVEL 1111
#define TXT_STARTLEVEL 1114
#define TXT_MUSICFILE 1113
#define TXT_WIDTH 1115
#define IDC_EDT1 1112
#define TXT_HIGHT 1116
#define BTN_SURCHMUSICFILE 1117
#define MusicFile_WIN 1200
#define MUSICFILE_LIST 1201

#Include "windows.bi"
#Include Once "win/commdlg.bi"
#Include "GL/gl.bi"
#Include "GL/glext.bi"

#Include "Inc/Log.bi"

Function glLoadFunction ( ByVal N As String, ByVal S As Integer Ptr ) As Any Ptr
	Dim R As Any Ptr
	R = wglGetProcAddress(StrPtr(N))
	If R Then
		Return R
	EndIf
	ErLog ( "glFunction "+Chr(34)+N+Chr(34)+" not found" )
	If S Then
		*S = -1
	EndIf
	Return 0
End Function

#Include "Inc/Mathematics_Types.bi"
#Include "Inc/Mathematics_Functiones.bi"
#Include "Inc/Mathematics_Functiones_dos.bi"
#Include "Inc/Mathematics_Vec.bi"
#Include "Inc/Mathematics_mat.bi"
#Include "Inc/Tabelle.bi"

Dim Shared Config As TABELLE
Dim Shared As Integer Screen_Width, Screen_Hight, Screen_Flag

#Include "Inc/Texture.bi"
#Include "Inc/FBO.bi"
#Include "Inc/Shader.bi"

#Include "Inc/Music.bi"

Dim Shared TextBlur As SHADER
Dim Shared Blur As SHADER
Dim Shared Schweif As SHADER
Dim Shared GameFBO As FBO
Dim Shared ParticleFBO As FBO
Dim Shared Gamer As String
Dim Shared LevelMusic As MUSIC Ptr
Dim Shared MusicVol(0 To 15) As Single

#Include "Inc/EPETool.bi"

Dim Shared Game As TABELLE
Dim Shared Level As TABELLE Ptr
Dim Shared Tool As TABELLE Ptr

Type ACTIVETOOL
	Na As String
	ID As Integer
End Type

Dim Shared AkTool As ACTIVETOOL

Dim Shared hInstance As HINSTANCE
hInstance = GetModuleHandle(NULL)
Dim Shared TOOLBOX As HWND
Dim Shared GLBOX As HWND
Dim Shared TOOLLIST As HWND
Dim Shared TOOLCBO As HWND
Dim Shared LEVELCBO As HWND
Dim Shared SETINGSCBO As HWND
Dim Shared TOOLWIN As HWND
Dim Shared GLRC As HGLRC
Dim Shared GLOLDPROC As Any Ptr
Dim Shared PixelFormat As PIXELFORMATDESCRIPTOR
Dim Shared SST As Integer
Dim Shared M As FRAMEMOUSE
Dim Shared rectalt As RECT
Dim Shared LastFile As String
LastFile = ExePath+"/Unnamed.epg"

Function CalcRect ( ByVal R1 As RECT, ByVal R2 As RECT ) As RECT
	Dim r As RECT
	Dim As Double Te,WP,HP
	Dim As Integer W,H,W2,H2,FW,FH,CW,CH,win
	W = R2.right
	H = R2.bottom
	CW = W
	CH = H
	WP = R1.right/W
	HP = R1.bottom/H
	If WP > HP Then
		W *= HP
		H *= HP
	Else
		W *= WP
		H *= WP
	EndIf
	FW = (R1.right-W)/2
	FH = (R1.bottom-H)/2
	Te = Log(CW)/Log(2)
	If Te <> Int(te) Then Te = Int(Te+1)
	W2 = 2^Te
	Te = Log(CH)/Log(2)
	If Te <> Int(te) Then Te = Int(Te+1)
	H2 = 2^Te
	If W2 > H2 Then 
		H2 = W2
	Else
		W2 = H2
	EndIf
	If W2 <> rectalt.right Or H2 <> rectalt.bottom Then
		GameFBO.Destroy()
		GameFBO.Create(W2,H2)
		GameFBO.NewTexture()
		GameFBO.NewTexture()
		GameFBO.UnBind()
		ParticleFBO.Destroy()
		ParticleFBO.Create(W2,H2)
		ParticleFBO.NewTexture()
		ParticleFBO.UnBind()
		rectalt.right = W2
		rectalt.bottom = H2
	EndIf
	r.left = FW
	r.right = W
	r.top = H
	r.bottom = FH
	Return r
End Function

Sub GL_PAINT(ByVal rect As RECT)
	Dim r As RECT
	Dim As Integer CW,CH
	If Level Then
		CW = Game.ItemI("width")
		CH = Game.ItemI("hight")
		glViewPort(0,0,rect.right,rect.bottom)
		glClearColor(1,1,1,1)
		glClear(GL_COLOR_BUFFER_BIT)
		r.right = CW
		r.bottom = CH
		r = CalcRect(rect,r)
		M.Frame = r
		M.MulX = CW
		M.MulY = CH
		
		ParticleFBO.Bind()
		glViewPort(0,0,CW,CH)
		glMatrixMode ( GL_PROJECTION )
		glLoadIdentity ()
		glOrtho ( 0, Game.ItemI("width"), 0, CH, -1, 1 )
		glMatrixMode ( GL_MODELVIEW )
		glLoadIdentity ()
		
		glEnable(GL_TEXTURE_2D)
		glBindTexture(GL_TEXTURE_2D,ParticleFBO.Texture(1))
		Schweif.Bind()
		glBegin(GL_QUADS)
		glTexCoord2f(0,0):glVertex2f(0,0)
		glTexCoord2f(CW/GameFBO.SizeX(),0):glVertex2f(CW,0)
		glTexCoord2f(CW/GameFBO.SizeX(),CH/GameFBO.SizeY()):glVertex2f(CW,CH)
		glTexCoord2f(0,CH/GameFBO.SizeY()):glVertex2f(0,CH)
		glEnd()
		Schweif.UnBind()
		glDisable(GL_TEXTURE_2D)
		
		UpdateParticle ()
		
		ParticleFBO.UnBind()
		GameFBO.Bind()
		glDrawBuffer(GL_COLOR_ATTACHMENT1_EXT)
		DrawToolLights ( )
		glEnable(GL_BLEND)
		glEnable(GL_TEXTURE_2D)
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
		glBindTexture(GL_TEXTURE_2D,ParticleFBO.Texture(1))
		glColor3f(1,1,1)
		glBegin(GL_QUADS)
		glTexCoord2f(0,0):glVertex2f(0,0)
		glTexCoord2f(CW/GameFBO.SizeX(),0):glVertex2f(CW,0)
		glTexCoord2f(CW/GameFBO.SizeX(),CH/GameFBO.SizeY()):glVertex2f(CW,CH)
		glTexCoord2f(0,CH/GameFBO.SizeY()):glVertex2f(0,CH)
		glEnd()
		glDisable(GL_BLEND)
		glDisable(GL_TEXTURE_2D)
		
		Blur.Bind
		Blur.UniformVec2 ( "ushift" , vec2 ( 0,1/GameFBO.SizeY()))
		glDrawBuffer(GL_COLOR_ATTACHMENT0_EXT)
		
		glEnable(GL_TEXTURE_2D)
		glBindTexture(GL_TEXTURE_2D,GameFBO.Texture(2))
		glBegin(GL_QUADS)
		glTexCoord2f(0,0):glVertex2f(0,0)
		glTexCoord2f(CW/GameFBO.SizeX(),0):glVertex2f(CW,0)
		glTexCoord2f(CW/GameFBO.SizeX(),CH/GameFBO.SizeY()):glVertex2f(CW,CH)
		glTexCoord2f(0,CH/GameFBO.SizeY()):glVertex2f(0,CH)
		glEnd()
		glDisable(GL_TEXTURE_2D)
		
		Blur.UniformVec2 ( "ushift" , vec2 ( 1/GameFBO.SizeX(),0))
		glDrawBuffer(GL_COLOR_ATTACHMENT1_EXT)
		
		glEnable(GL_TEXTURE_2D)
		glBindTexture(GL_TEXTURE_2D,GameFBO.Texture(1))
		glBegin(GL_QUADS)
		glTexCoord2f(0,0):glVertex2f(0,0)
		glTexCoord2f(CW/GameFBO.SizeX(),0):glVertex2f(CW,0)
		glTexCoord2f(CW/GameFBO.SizeX(),CH/GameFBO.SizeY()):glVertex2f(CW,CH)
		glTexCoord2f(0,CH/GameFBO.SizeY()):glVertex2f(0,CH)
		glEnd()
		glDisable(GL_TEXTURE_2D)
		
		Blur.UnBind
		GameFBO.UnBind()
		
		glViewPort(r.left,r.bottom,r.right,r.top)
		glMatrixMode ( GL_PROJECTION )
		glLoadIdentity ()
		glOrtho ( 0, CW, 0, CH, -1, 1 )
		glMatrixMode ( GL_MODELVIEW )
		glLoadIdentity ()
		
		glEnable(GL_TEXTURE_2D)
		glColor4f(1,1,1,1)
		glBindTexture(GL_TEXTURE_2D,ParticleFBO.Texture(1))
		glBegin(GL_QUADS)
		glTexCoord2f(0,0):glVertex2f(0,0)
		glTexCoord2f(CW/GameFBO.SizeX(),0):glVertex2f(CW,0)
		glTexCoord2f(CW/GameFBO.SizeX(),CH/GameFBO.SizeY()):glVertex2f(CW,CH)
		glTexCoord2f(0,CH/GameFBO.SizeY()):glVertex2f(0,CH)
		glEnd()
		
		glEnable(GL_BLEND)
		glBlendFunc(GL_ONE,GL_ONE)
		glBindTexture(GL_TEXTURE_2D,GameFBO.Texture(2))
		glBegin(GL_QUADS)
		glTexCoord2f(0,0):glVertex2f(0,0)
		glTexCoord2f(CW/GameFBO.SizeX(),0):glVertex2f(CW,0)
		glTexCoord2f(CW/GameFBO.SizeX(),CH/GameFBO.SizeY()):glVertex2f(CW,CH)
		glTexCoord2f(0,CH/GameFBO.SizeY()):glVertex2f(0,CH)
		glEnd()
		glDisable(GL_BLEND)
		glDisable(GL_TEXTURE_2D)
		
		UpdateTools ( @M )
		glFlush()
		M.XA = M.X
		M.YA = M.Y
		M.BA = M.B
		For i As Integer = 0 To 15
			LevelMusic->setChannelVol(i,MusicVol(i))
		Next
		LevelMusic->update()
	EndIf
End Sub

Function GL_TIMER_PROC(ByVal hWin As HWND, ByVal uMsg as UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	InvalidateRect(GLBOX,NULL,TRUE)
	Return TRUE
End Function
Function GL_PAINT_PROC(ByVal hWin As HWND, ByVal uMsg as UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	Dim ps As PAINTSTRUCT
	Dim rect As RECT
	Select Case uMsg
		Case WM_PAINT
			Dim As HDC hdc = GetDC(hWin)
			GetClientRect(GLBOX,@rect)
			GL_PAINT(rect)
			swapbuffers(hdc)
			ReleaseDC(hWin, hdc)
			Return 0
		Case WM_MOUSEMOVE
			M.Update(LoWord(LParam),HiWord(LParam),IIf(WParam And MK_LBUTTON,1,0))
	End Select
	Return CallWindowProc(GLOLDPROC,hWin,uMsg,wParam,lParam)
End Function

Const szNULL=!"\0"

Function OpenFFile ( ByVal WND As HWND, ByVal szFilter As String, ByVal Title As String ) As String
	Dim ofn As OPENFILENAME
	Dim buff As ZString*260
	ofn.lStructSize = SizeOf(OPENFILENAME)
	ofn.hwndOwner = WND
	ofn.hInstance = hInstance
	ofn.lpstrInitialDir = StrPtr(LastFile)
	buff = String(260,0)
	ofn.lpstrFile = @buff
	ofn.nMaxFile = 260
	ofn.lpstrFilter = StrPtr(szFilter)
	ofn.lpstrTitle = StrPtr(Title)
	ofn.Flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_EXPLORER
	If GetOpenFileName(@ofn) Then
		LastFile = buff
		Return buff
	EndIf
End Function
Function SaveFFile ( ByVal WND As HWND, ByVal szFilter As String, ByVal Title As String ) As String
	Dim ofn As OPENFILENAME
	Dim buff As ZString*260
	ofn.lStructSize = SizeOf(OPENFILENAME)
	ofn.hwndOwner = Wnd
	ofn.hInstance = hInstance
	ofn.lpstrInitialDir = StrPtr(LastFile)
	buff = String(260,0)
	ofn.lpstrFile = @buff
	ofn.nMaxFile = 260
	ofn.lpstrFilter = StrPtr(szFilter)
	ofn.lpstrTitle = StrPtr(Title)
	ofn.Flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_EXPLORER
	If GetSaveFileName(@ofn) Then
		LastFile = buff
		Return buff
	EndIf
End Function

Sub INIT_GL ()
	Dim DC As HDC
	
	DC = GetDC(GLBOX)
	SetPixelFormat(DC, ChoosePixelFormat(DC,@PixelFormat), @PixelFormat)
	GLRC = wglCreateContext(DC)
	wglMakeCurrent (DC, GLRC)
	GLOLDPROC = Cast(Any Ptr,SetWindowLong(GLBOX,GWL_WNDPROC,Cast(Integer,@GL_PAINT_PROC)))
	SetTimer(GLBOX,NULL,10,Cast(Any Ptr,@GL_TIMER_PROC))
	
	Dim As String GLVersion, ShaderVersion
	GLVersion = *glGetString ( GL_VERSION )
	InLog ( "Version: "+GLVersion )
	InLog ( "Renderer: "+*glGetString ( GL_RENDERER ) )
	InLog ( "Vendor: "+*glGetString ( GL_VENDOR ) )
	
	If Val ( GLVersion ) < 2.0 Then
		ErLog ( "Version must be higher then 2.0.0" )
		ErLog ( "GL Init failed" )
		Exit Sub
	EndIf
	
	ShaderVersion = *glGetString ( GL_SHADING_LANGUAGE_VERSION_ARB )
	
	If Val ( ShaderVersion ) < 1 Then 
		ErLog ( "No Shader on this hardware" )
		ErLog ( "GL Init failed" )
		Exit Sub
	Else
		InLog ( "ShaderVersion: "+ShaderVersion )
	EndIf
	
	INIT_SHADER ()
	INIT_FBO ()
	
	If ErrorDetected () Then
		ErLog ( "GL Init failed" )
	Else
		InLog ( "GL Init finished" )
	EndIf
	
End Sub

PixelFormat.nSize = Len(PIXELFORMATDESCRIPTOR)
PixelFormat.nVersion = 1
PixelFormat.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER
PixelFormat.iPixelType = PFD_TYPE_RGBA
PixelFormat.cColorBits = 32
PixelFormat.cRedBits = 0
PixelFormat.cRedShift = 0
PixelFormat.cGreenBits = 0
PixelFormat.cGreenShift = 0
PixelFormat.cBlueBits = 0
PixelFormat.cBlueShift = 0
PixelFormat.cAlphaBits = 0
PixelFormat.cAlphaShift = 0
PixelFormat.cAccumBits = 0
PixelFormat.cDepthBits = 32
PixelFormat.cStencilBits = 0
PixelFormat.cAuxBuffers = 0
PixelFormat.iLayerType = PFD_MAIN_PLANE
PixelFormat.bReserved = 0
PixelFormat.dwLayerMask = 0
PixelFormat.dwVisibleMask = 0
PixelFormat.dwDamageMask = 0
