Sub LoadGames ( ByVal B As LISTBOX Ptr )
	B->Destroy()
	Dim Dat As String
	Dim Nam As String
	Dim BoxAdd As BUTTON Ptr
	Dim GamerTabelle As TABELLE
	Dim LevelTabelle As TABELLE
	Dim Level As String
	Dim T As Double
	Dim T1 As Double
	Dim G As String
	Dat = Dir(Config.ItemS("GameFile")+"*.epg")
	GamerTabelle = LoadXML ( Config.ItemS("GamerFile") + Gamer + ".eps" )
	Do Until Dat = ""
		LevelTabelle.Destroy()
		LevelTabelle = TABELLE()
		LevelTabelle = LoadXML ( Config.ItemS("GameFile") + Dat )
		Level = LevelTabelle.ItemS("StartLevel")
		T = 0
		For i As Integer = Len(Dat) To 1 Step -1
			If Mid(Dat,i,1) = "." Then
				G = Mid(Dat,1,i-1)
				Exit For
			EndIf
		Next
		Do Until Level = ""
			T1 = GamerTabelle.ItemD(G+"[1]."+Level)
			If T1 = 0 Then
				T = 0
				Exit Do
			Else
				T += T1
			EndIf
			Level = LevelTabelle.ItemS(Level+"[1].NextLevel")
		Loop
		BoxAdd = B->AddItem ()
		For i As Integer = Len(Dat) To 1 Step -1
			If Mid(Dat,i,1) = "." Then
				Nam = Mid(Dat,1,i-1)
				Exit For
			EndIf
		Next
		If T = 0 Then
			BoxAdd->Title = Nam+"  [--]"
		Else
			BoxAdd->Title = Nam+"  ["+Str(Int(T))+"]"
		EndIf
		BoxAdd->AnchorX = GUI_TM_LEFT
		Dat = Dir()
		
	Loop
	GamerTabelle.Destroy()
	LevelTabelle.Destroy()
End Sub

Sub LoadLevel ( ByVal B As LISTBOX Ptr, ByVal Game As String )
	B->Destroy()
	Dim LevelTabelle As TABELLE
	Dim GamerTabelle As TABELLE
	Dim Level As String
	Dim BoxAdd As BUTTON Ptr
	Dim T As Integer
	LevelTabelle = LoadXML ( Config.ItemS("GameFile") + Game + ".epg" )
	GamerTabelle = LoadXML ( Config.ItemS("GamerFile") + Gamer + ".eps" )
	Level = LevelTabelle.ItemS("Startlevel")
	Do Until Level = ""
		BoxAdd = B->AddItem ()
		T = GamerTabelle.ItemI(Game+"[1]."+Level)
		If T = 0 Then
			BoxAdd->Title = Level+"  [--]"
		Else
			BoxAdd->Title = Level+"  ["+Str(T)+"]"
		EndIf
		BoxAdd->AnchorX = GUI_TM_LEFT
		If T = 0 Then Exit Do
		Level = LevelTabelle.ItemS(Level+"[1].NextLevel")
	Loop
	LevelTabelle.Destroy()
	GamerTabelle.Destroy()
End Sub

Sub LoadGamers ( ByVal B As LISTBOX Ptr )
	B->Destroy()
	Dim Dat As String
	Dim Nam As String
	Dim BoxAdd As BUTTON Ptr
	BoxAdd = B->AddItem ()
	BoxAdd->Title = "New Gamer"
	BoxAdd->AnchorX = GUI_TM_LEFT
	Dat = Dir(Config.ItemS("GamerFile")+"*.eps")
	Do Until Dat = ""
		BoxAdd = B->AddItem ()
		For i As Integer = Len(Dat) To 1 Step -1
			If Mid(Dat,i,1) = "." Then
				Nam = Mid(Dat,1,i-1)
				Exit For
			EndIf
		Next
		BoxAdd->Title = Nam
		BoxAdd->AnchorX = GUI_TM_LEFT
		Dat = Dir()
	Loop
End Sub

Sub BlurMenue()
	glEnable ( GL_TEXTURE_2D )
	glColor4f(1,1,1,1)
	glBindTexture ( GL_TEXTURE_2D, TextFBO.Texture(2) )
	glBegin ( GL_QUADS )
	glTexCoord2f ( 0, 0 ): glVertex2f ( 0, 0 )
	glTexCoord2f ( 0, Screen_Hight/TextFBOSize ): glVertex2f ( 0, Screen_Hight )
	glTexCoord2f ( Screen_Width/TextFBOSize, Screen_Hight/TextFBOSize ): glVertex2f ( Screen_Width, Screen_Hight )
	glTexCoord2f ( Screen_Width/TextFBOSize, 0 ): glVertex2f ( Screen_Width, 0 )
	glEnd ()
	glDisable ( GL_TEXTURE_2D )
	
	Blur.Bind ()
	TextFBO.Bind ()
	
	glLoadIdentity ()
	glDrawBuffer ( GL_COLOR_ATTACHMENT1_EXT )
	Blur.UniformVec2 ( "ushift" , vec2 ( 1/TextFBOSize*0.7,0))
	
	glClear ( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
	glEnable ( GL_TEXTURE_2D )
	glBindTexture ( GL_TEXTURE_2D, TextFBO.Texture(1) )
	glBegin ( GL_QUADS )
	glTexCoord2f ( 0, 0 ): glVertex2f ( 0, 0 )
	glTexCoord2f ( 0, Screen_Hight/TextFBOSize ): glVertex2f ( 0, Screen_Hight )
	glTexCoord2f ( Screen_Width/TextFBOSize, Screen_Hight/TextFBOSize ): glVertex2f ( Screen_Width, Screen_Hight )
	glTexCoord2f ( Screen_Width/TextFBOSize, 0 ): glVertex2f ( Screen_Width, 0 )
	glEnd ()
	glDisable ( GL_TEXTURE_2D )
	
	TextFBO.UnBind ()
	
	Blur.UniformVec2 ( "ushift" , vec2 ( 0,1/TextFBOSize*0.7))
	glEnable(GL_BLEND)
	glBlendFunc(GL_ONE,GL_ONE)
	glEnable ( GL_TEXTURE_2D )
	glBindTexture ( GL_TEXTURE_2D, TextFBO.Texture(2) )
	glBegin ( GL_QUADS )
	glTexCoord2f ( 0, 0 ): glVertex2f ( 0, 0 )
	glTexCoord2f ( 0, Screen_Hight/TextFBOSize ): glVertex2f ( 0, Screen_Hight )
	glTexCoord2f ( Screen_Width/TextFBOSize, Screen_Hight/TextFBOSize ): glVertex2f ( Screen_Width, Screen_Hight )
	glTexCoord2f ( Screen_Width/TextFBOSize, 0 ): glVertex2f ( Screen_Width, 0 )
	glEnd ()
	glDisable ( GL_TEXTURE_2D )
	glDisable ( GL_BLEND )
	Blur.UnBind ()
	glFlush()
End Sub

Function EndMenue ( ByVal M As MOUSE Ptr ) As Integer
	Dim DB(0 To 1) As UInteger => {GL_COLOR_ATTACHMENT0_EXT,GL_COLOR_ATTACHMENT1_EXT}
	Dim As BUTTON BYes, BNo
	Dim Ending As Integer
	BYes.Position = RECT ( Screen_Width/2-100,Screen_Width/2+100,Screen_Hight/2-50,Screen_Hight/2-10)
	BYes.Title = "Yes"
	BYes.AnchorX = GUI_TM_MIDDLE
	BNo.Position = RECT ( Screen_Width/2-100,Screen_Width/2+100,Screen_Hight/2+10,Screen_Hight/2+50)
	BNo.Title = "No"
	BNo.AnchorX = GUI_TM_MIDDLE
	
	Do
		M->Update
		TextBlur.Bind ()
		TextFBO.Bind ()
		glLoadIdentity ()
  		glDrawBuffers (2, @DB(0))
 		glClear ( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
 		
		guitmSetPosition ( vec2(0,10) )
		guitmSetScale ( 3 )
		guitmSetColor(vec4(1,0,0,1))
		guitmwrite ( "End "+GameName+"?" )
		guitmSetScale ( 2 )
		If BYes.Update(*M) Then 
			Function = -1
			ending = 1
		EndIf
		If BNo.Update(*M) Then
			Function = 0
			ending = 1
		EndIf
		TextFBO.UnBind ()
		TextBlur.UnBind ()
		
		BlurMenue()
		
		Render()
		If MultiKey(1) Then
 			ending = 2
 		EndIf
 		If MultiKey(1) = 0 And ending = 2 Then
 			ending = 1
 			Function = 0
 		EndIf
		If InKey = Chr(255)+"k" Then 
			Function = -1
			ending = 1
		EndIf
	Loop Until ending = 1
	BYes.Destroy()
	BNo.Destroy()
End Function

Function OptionsMenue ( ByVal M As MOUSE Ptr ) As Integer
	Dim DB(0 To 1) As UInteger => {GL_COLOR_ATTACHMENT0_EXT,GL_COLOR_ATTACHMENT1_EXT}
	Dim As BUTTON BOk, BCancel, BSize, BFullscreen
	Dim As LISTBOX Box
	Dim As Integer Ending, Temp, WhatSelect, NSW, NSH, NFSF
	NSW = Screen_Width
	NSH = Screen_Hight
	NFSF = (Screen_Flag And &H01)<>0
	BOk.Position = RECT ( 10,210,Screen_Hight-10-32,Screen_Hight-10)
	BOk.Title = "OK"
	BOk.AnchorX = GUI_TM_MIDDLE
	BCancel.Position = RECT ( Screen_Width-210,Screen_Width-10,Screen_Hight-10-32,Screen_Hight-10)
	BCancel.Title = "Cancel"
	BCancel.AnchorX = GUI_TM_MIDDLE
	BSize.Position = RECT ( 100,Screen_Width/2-10,100,132)
	BSize.Title = "Size: "+Str(NSW)+"x"+Str(NSH)
	BSize.AnchorX = GUI_TM_RIGHT
	BFullscreen.Position = RECT ( 100,Screen_Width/2-10,134,166)
	If (NFSF) Then
		BFullscreen.Title = "Fullscreen: true"
	Else
		BFullscreen.Title = "Fullscreen: false"
	EndIf
	BFullscreen.AnchorX = GUI_TM_RIGHT
	Box.Position = RECT ( Screen_Width/2+10,Screen_Width-100,100,Screen_Hight-100)
	
	Do
		M->Update
		TextBlur.Bind ()
		TextFBO.Bind ()
		glLoadIdentity ()
  		glDrawBuffers (2, @DB(0))
 		glClear ( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
 		
		guitmSetPosition ( vec2(0,10) )
		guitmSetScale ( 3 )
		guitmSetColor(vec4(1,0,0,1))
		guitmwrite ( GameName+" Option Menue" )
		guitmSetScale ( 2 )
		If WhatSelect Then
			Temp = Box.Update(*M)
			If Temp Then
				Select Case WhatSelect
					Case 1
						Dim S As String
						Dim As Integer p
						S = Box.ItemP(Temp)->Title
						p = InStr(S,"x")
						NSW = Val(Mid(S,1,p-1))
						NSH = Val(Mid(S,p+1))
						BSize.Title = "Size: "+Str(NSW)+"x"+Str(NSH)
					Case 2
						If Box.ItemP(Temp)->Title="true" Then
							NFSF = 1
							BFullscreen.Title = "Fullscreen: true"
						Else
							NFSF = 0
							BFullscreen.Title = "Fullscreen: false"
						EndIf
				End Select
				WhatSelect = 0
			EndIf
			If M->LButton=M->Down And Not(Box.Position.left<M->X And Box.Position.right>M->X And Box.Position.top<M->Y And Box.Position.bottom>M->Y) Then
				WhatSelect = 0
			EndIf
		EndIf
		If BOk.Update(*M) Then
			Config.ItemI ( "Screen[1].Width" ) = NSW
			Config.ItemI ( "Screen[1].Hight" ) = NSH
			Config.ItemI ( "Screen[1].FullScreen" ) = NFSF
			SaveXML ( "Config.epc", Config )
			WiederHole = -1
			Function = -1
			ending = 1
		EndIf
		If BCancel.Update(*M) Then
			Function = 0
			ending = 1
		EndIf
		If BSize.Update(*M,IIf(WhatSelect=1,1,0)) Then
			Dim modus As Integer
			Dim BP As BUTTON Ptr
			WhatSelect = 1
			Box.Destroy()
			modus = ScreenList(32)
			While(modus)
				BP = Box.AddItem()
				BP->AnchorX = GUI_TM_LEFT
				BP->Title = Str(HiWord(modus))+"x"+Str(LoWord(modus))
			   modus = ScreenList()
			Wend
		EndIf
		If BFullscreen.Update(*M,IIf(WhatSelect=2,1,0)) Then
			Dim BP As BUTTON Ptr
			WhatSelect = 2
			Box.Destroy()
			BP = Box.AddItem()
			BP->AnchorX = GUI_TM_LEFT
			BP->Title = "true"
			BP = Box.AddItem()
			BP->AnchorX = GUI_TM_LEFT
			BP->Title = "false"
		EndIf
		TextFBO.UnBind ()
		TextBlur.UnBind ()
		
		BlurMenue()
		
		Render()
		If MultiKey(1) Then
 			ending = 2
 		EndIf
 		If MultiKey(1) = 0 And ending = 2 Then
 			ending = 1
 			Function = 0
 		EndIf
		If InKey = Chr(255)+"k" Then 
			Function = -1
			ending = 1
		EndIf
	Loop Until ending = 1
	BOk.Destroy()
	BCancel.Destroy()
	BSize.Destroy()
	BFullscreen.Destroy()
	Box.Destroy()
End Function

Function LevelMenue ( ByVal Game As String, ByVal M As MOUSE Ptr ) As Integer
	Dim DB(0 To 1) As UInteger => {GL_COLOR_ATTACHMENT0_EXT,GL_COLOR_ATTACHMENT1_EXT}
	Dim As BUTTON BBack, BEnd, BOption
	Dim Box As LISTBOX
	Dim Ending As Integer
	Dim Temp As Integer
	Dim N As String
	Dim GameData As TABELLE
	Dim LightFBO As FBO
	BEnd.Position = RECT ( 10,210,Screen_Hight-10-32,Screen_Hight-10)
	BEnd.Title = "End"
	BEnd.AnchorX = GUI_TM_MIDDLE
	BBack.Position = RECT ( Screen_Width-210,Screen_Width-10,Screen_Hight-10-32,Screen_Hight-10)
	BBack.Title = "Back"
	BBack.AnchorX = GUI_TM_MIDDLE
	BOption.Position = RECT ( Screen_Width/2-100,Screen_Width/2+100,Screen_Hight-10-32,Screen_Hight-10)
	BOption.Title = "Option"
	BOption.AnchorX = GUI_TM_MIDDLE
	Box.Position = RECT ( 100,Screen_Width-100,100,Screen_Hight-100)
	LoadLevel(@Box,Game)
	GameData = LoadXML(Config.ItemS("GameFile") + Game +".epg" )
	Do
		M->Update
		TextBlur.Bind ()
		TextFBO.Bind ()
		glLoadIdentity ()
  		glDrawBuffers (2, @DB(0))
 		glClear ( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
 		
		guitmSetPosition ( vec2(0,10) )
		guitmSetScale ( 3 )
		guitmSetColor(vec4(1,0,0,1))
		guitmwrite ( GameName+" Level Menue" )
		guitmSetScale ( 2 )
		
		glColor4f(1,1,1,1)
 		Temp = Box.Update(*M)
 		If Temp > 0 Then
 			TextFBO.UnBind ()
			TextBlur.UnBind ()
			N = Box.ItemP(Temp)->Title
			For i As Integer = Len(N) To 1 Step -1
				If Mid(N,i,1) = "[" Then
					N = Mid(N,1,i-3)
					Exit For
				EndIf
			Next
			Dim As Double Te
			Dim As Integer W,H,W2,H2
			W = GameData.ItemI("width")
			H = GameData.ItemI("hight")
			Te = Log(W)/Log(2)
			If Te <> Int(te) Then Te = Int(Te+1)
			W2 = 2^Te
			Te = Log(H)/Log(2)
			If Te <> Int(te) Then Te = Int(Te+1)
			H2 = 2^Te
			If W2 > H2 Then 
				H2 = W2
			Else
				W2 = H2
			EndIf
			glClearColor(1,1,1,0)
			glClear ( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
			LightFBO.Create(W2,H2)
			LightFBO.NewTexture()
			LightFBO.NewTexture()
			LightFBO.UnBind()
			Do Until N = ""
	 			If RunGame(@GameData,Game,N,@LightFBO) Then
	 				LightFBO.Destroy()
	 				Function = -1
					Exit Do, Do
	 			EndIf
			Loop
	 		LightFBO.Destroy()
	 		
 			guitmSetViewPort ( 0, Screen_Width, 0, Screen_Hight )
			guitmSetWriteRect ( 0, Screen_Width, 0, Screen_Hight )
			guitmBindFont ( Font )
			guitmSetFrameSize( vec2(2,2) )
			guitmSetAnchor ( GUI_TM_MIDDLE, GUI_TM_TOP )
			guitmEnable ( GUI_TM_MULTI_LINE Or GUI_TM_AUTO_BRAKE )
			LoadLevel(@Box,Game)
 			Continue Do
 		EndIf
 		If BBack.Update(*M) Then 
			Function = 0
			ending = 1
 		EndIf
 		If BEnd.Update(*M) Then 
			If EndMenue ( M ) Then
				Ending = 1
				Function = -1
			EndIf
 		EndIf
 		If BOption.Update(*M) Then 
			If OptionsMenue ( M ) Then
				Ending = 1
				Function = -1
			EndIf
		EndIf
 		TextFBO.UnBind ()
		TextBlur.UnBind ()
		
		BlurMenue()
 		Render()
 		If MultiKey(1) Then
 			ending = 2
 		EndIf
 		If MultiKey(1) = 0 And ending = 2 Then
 			ending = 1
 			Function = 0
 		EndIf
 		If InKey = Chr(255)+"k" Then 
 			Function = -1
			ending = 1
		EndIf
	Loop Until ending = 1
	GameData.Destroy()
	BBack.Destroy()
	BEnd.Destroy()
	BOption.Destroy()
	Box.Destroy()
End Function

Function GameMenue ( ByVal M As MOUSE Ptr ) As Integer
	Dim DB(0 To 1) As UInteger => {GL_COLOR_ATTACHMENT0_EXT,GL_COLOR_ATTACHMENT1_EXT}
	Dim As BUTTON BBack, BEnd, BOption
	Dim Box As LISTBOX
	Dim Ending As Integer
	Dim Temp As Integer
	Dim Game As String
	
	BEnd.Position = RECT ( 10,210,Screen_Hight-10-32,Screen_Hight-10)
	BEnd.Title = "End"
	BEnd.AnchorX = GUI_TM_MIDDLE
	BBack.Position = RECT ( Screen_Width-210,Screen_Width-10,Screen_Hight-10-32,Screen_Hight-10)
	BBack.Title = "Back"
	BBack.AnchorX = GUI_TM_MIDDLE
	BOption.Position = RECT ( Screen_Width/2-100,Screen_Width/2+100,Screen_Hight-10-32,Screen_Hight-10)
	BOption.Title = "Option"
	BOption.AnchorX = GUI_TM_MIDDLE
	Box.Position = RECT ( 100,Screen_Width-100,100,Screen_Hight-100)
	LoadGames(@Box)
	
	Do
		
		M->Update
		TextBlur.Bind ()
		TextFBO.Bind ()
		glLoadIdentity ()
  		glDrawBuffers (2, @DB(0))
 		glClear ( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
		guitmSetPosition ( vec2(0,10) )
		guitmSetScale ( 3 )
		guitmSetColor(vec4(1,0,0,1))
		guitmwrite ( GameName+" Game Menue" )
		guitmSetScale ( 2 )
		
		glColor4f(1,1,1,1)
 		Temp = Box.Update(*M)
 		If Temp > 0 Then
 			Game = Box.ItemP(Temp)->Title
 			For i As Integer = Len(Game) To 1 Step -1
				If Mid(Game,i,1) = "[" Then
					Game = Mid(Game,1,i-3)
					Exit For
				EndIf
			Next
 			If LevelMenue(Game,M) Then
 				ending = 1
 				Function = -1
 			EndIf
 			LoadGames(@Box)
 		EndIf
 		If BBack.Update(*M) Then
			Ending = 1
			Function = 0
 		EndIf
 		If BEnd.Update(*M) Then
			If EndMenue ( M ) Then
				Ending = 1
				Function = -1
			EndIf
 		EndIf
 		If BOption.Update(*M) Then 
			If OptionsMenue ( M ) Then
				Ending = 1
				Function = -1
			EndIf
		EndIf
 		TextFBO.UnBind ()
		TextBlur.UnBind ()
		
		BlurMenue()
		
		Render()
		If MultiKey(1) Then
 			ending = 2
 		EndIf
 		If MultiKey(1) = 0 And ending = 2 Then
 			ending = 1
 			Function = 0
 		EndIf
		If InKey = Chr(255)+"k" Then 
			Function = -1
			ending = 1
		EndIf
	Loop Until ending = 1
	BBack.Destroy()
	BEnd.Destroy()
	BOption.Destroy()
	Box.Destroy()
End Function

Function NewGamerMenue ( ByVal M As MOUSE Ptr ) As Integer
	Dim DB(0 To 1) As UInteger => {GL_COLOR_ATTACHMENT0_EXT,GL_COLOR_ATTACHMENT1_EXT}
	Dim As BUTTON BBack, BEnd, BOk
	Dim Ending As Integer
	Dim k As String
	Dim LTime As Double
	Dim State As Integer
	
	BEnd.Position = RECT ( 10,210,Screen_Hight-10-32,Screen_Hight-10)
	BEnd.Title = "End"
	BEnd.AnchorX = GUI_TM_MIDDLE
	BBack.Position = RECT ( Screen_Width-210,Screen_Width-10,Screen_Hight-10-32,Screen_Hight-10)
	BBack.Title = "Back"
	BBack.AnchorX = GUI_TM_MIDDLE
	BOk.Position = RECT ( Screen_Width/2-100,Screen_Width/2+100,Screen_Hight/2+10,Screen_Hight/2+50)
	BOk.Title = "OK"
	BOk.AnchorX = GUI_TM_MIDDLE
	
	Gamer = ""
	
	Do
		k = InKey
		M->Update
		TextBlur.Bind ()
		TextFBO.Bind ()
		glLoadIdentity ()
  		glDrawBuffers (2, @DB(0))
 		glClear ( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
		guitmSetPosition ( vec2(0,10) )
		guitmSetScale ( 3 )
		guitmSetColor(vec4(1,0,0,1))
		guitmwrite ( GameName+" Gamer Menue" )
		guitmSetScale ( 2 )
		
		glColor4f(1,1,1,1)
		
		guitmSetPosition ( vec2(0,Screen_Hight/2-50) )
		guitmSetColor(vec4(1,1,1,0))
		If LTime+0.5<Timer Then
			LTime = Timer
			State Xor= -1
		EndIf
		If State Then
			guitmwrite ( Gamer+"|" )
		Else
			guitmwrite ( Gamer+Chr(127) )
		EndIf
		If BOK.Update(*M) Then
			Dim FF As Integer = FreeFile
			Open Config.ItemS("GamerFile")+Gamer+".eps" For Output As #FF
			Close #FF
			Ending = 1
			Function = 1
 		EndIf
 		If BBack.Update(*M) Then
			Ending = 1
			Function = 0
 		EndIf
 		If BEnd.Update(*M) Then
			If EndMenue ( M ) Then
				Ending = 1
				Function = -1
			EndIf
		EndIf
 		TextFBO.UnBind ()
		TextBlur.UnBind ()
		
		BlurMenue()
		
		Render()
		If MultiKey(1) Then
 			ending = 2
 		EndIf
 		If MultiKey(1) = 0 And ending = 2 Then
 			Ending = 1
			Function = 0
 		EndIf
		If k = Chr(255)+"k" Then 
			Function = -1
			ending = 1
		EndIf
		Select Case k
			Case "A" To "Z","a" To "z","0" To "9","_"
				Gamer += k
			Case Chr(8)
				Gamer = Mid(Gamer,1,Len(Gamer)-1)
			Case Chr(13)
				Dim FF As Integer = FreeFile
				Open Config.ItemS("GamerFile")+Gamer+".eps" For Output As #FF
				Close #FF
				Ending = 1
				Function = 1
		End Select
	Loop Until ending = 1
	BBack.Destroy()
	BEnd.Destroy()
	BOk.Destroy()
End Function

Sub MainMenue ()
	Dim DB(0 To 1) As UInteger => {GL_COLOR_ATTACHMENT0_EXT,GL_COLOR_ATTACHMENT1_EXT}
	Dim As BUTTON BEnd, BOption
	Dim Box As LISTBOX
	Dim Ending As Integer
	Dim Temp As Integer
	Dim M As MOUSE
	
	guitmSetViewPort(0,Screen_Width,0,Screen_Hight)
	guitmSetWriteRect(0,Screen_Width,0,Screen_Hight)
	guitmBindFont(Font)
	guitmSetFrameSize(vec2(2,2))
	guitmSetAnchor ( GUI_TM_MIDDLE , GUI_TM_TOP )
	BEnd.Position = RECT ( 10,210,Screen_Hight-10-32,Screen_Hight-10)
	BEnd.Title = "End"
	BEnd.AnchorX = GUI_TM_MIDDLE
	BOption.Position = RECT ( Screen_Width/2-100,Screen_Width/2+100,Screen_Hight-10-32,Screen_Hight-10)
	BOption.Title = "Option"
	BOption.AnchorX = GUI_TM_MIDDLE
	Box.Position = RECT ( 100,Screen_Width-100,100,Screen_Hight-100)
	LoadGamers ( @Box )
	
	Do
		M.Update
		TextBlur.Bind ()
		TextFBO.Bind ()
		glLoadIdentity ()
  		glDrawBuffers (2, @DB(0))
 		glClear ( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT )
 		
		guitmSetPosition ( vec2(0,10) )
		guitmSetScale ( 3 )
		guitmSetColor(vec4(1,0,0,1))
		guitmwrite ( GameName+" Gamer Menue" )
		guitmSetScale ( 2 )
		
		glColor4f(1,1,1,1)
 		Temp = Box.Update(M)
 		If Temp > 0 Then
 			TextFBO.UnBind ()
			TextBlur.UnBind ()
			Gamer = Box.ItemP(Temp)->Title
			If Gamer = "New Gamer" Then
				Temp = NewGamerMenue (@M)
				If Temp = 1 Then
					If GameMenue(@M) Then
			 			ending = 1
			 			Exit Do
					EndIf
				ElseIf Temp = -1 Then
					Exit Do
				EndIf
			Else
				If GameMenue(@M) Then
		 			ending = 1
		 			Exit Do
		 		EndIf
			EndIf
 			guitmSetViewPort ( 0, Screen_Width, 0, Screen_Hight )
			guitmSetWriteRect ( 0, Screen_Width, 0, Screen_Hight )
			guitmBindFont ( Font )
			guitmSetLineBrake( Chr(13,10) )
			guitmSetFrameSize( vec2(2,2) )
			guitmSetAnchor ( GUI_TM_MIDDLE, GUI_TM_TOP )
			guitmEnable ( GUI_TM_MULTI_LINE Or GUI_TM_AUTO_BRAKE )
			LoadGamers ( @Box )
 			Continue Do
 		EndIf
 		If BEnd.Update(M) Then 
			If EndMenue ( @M ) Then
				Ending = 1
			EndIf
 		EndIf
 		If BOption.Update(M) Then 
			If OptionsMenue ( @M ) Then
				Ending = 1
			EndIf
		EndIf
 		TextFBO.UnBind ()
		TextBlur.UnBind ()
		
		BlurMenue()
 		Render()
 		If MultiKey(1) Then
 			ending = 2
 		EndIf
 		If MultiKey(1) = 0 And ending = 2 Then
 			If EndMenue ( @M ) Then
				Ending = 1
 			Else
 				ending = 0
			EndIf
 		EndIf
 		If InKey = Chr(255)+"k" Then 
			ending = 1
		EndIf
	Loop Until ending = 1
	BEnd.Destroy()
	BOption.Destroy()
	Box.Destroy()
End Sub
