
#Macro InitOperator(Op,nu,na)
Operator op ( ByVal v1 As vec##nu , ByVal v2 As vec##nu ) As vec##nu
	Dim ret As vec##nu
	vec##na ( @ret.x , nu , @v1.x , nu , @v2.x , nu )
	Return ret
End Operator
Operator op ( ByVal v1 As float , ByVal v2 As vec##nu ) As vec##nu
	Dim ret As vec##nu
	vec##na ( @ret.x , nu , @v1 , 1 , @v2.x , nu )
	Return ret
End Operator
Operator op ( ByVal v1 As vec##nu , ByVal v2 As float ) As vec##nu
	Dim ret As vec##nu
	vec##na ( @ret.x , nu , @v1.x , nu , @v2 , 1 )
	Return ret
End Operator
#EndMacro
#Macro WritFunction1para(na,nu,zu,pa)
#If pa = 1
Function na OverLoad ( ByVal z As vec##nu ) As zu
	#If zu = float Or zu = byte
	Return vec##na ( @z.x , nu )
	#Else
	Dim ret As zu
	vec##na ( @ret.x , nu ,  @z.x , nu )
	Return ret
	#endif
End Function
#ElseIf pa = 2
Function na OverLoad ( ByVal z1 As vec##nu , ByVal z2 As vec##nu ) As zu
	#If zu = float Or zu = Byte
	Return vec##na ( @z1.x , nu , @z2.x , nu )
	#Else
	Dim ret As zu
	vec##na ( @ret.x , nu , @z1.x , nu , @z2.x , nu )
	Return ret
	#endif
End Function
#ElseIf pa = 3
Function na OverLoad ( ByVal z1 As vec##nu ,  ByVal z2 As vec##nu ,  ByVal z3 As vec##nu ) As zu
	#If zu = float Or zu = Byte
	Return vec##na ( @z1.x , nu , @z2.x , nu , @z3.x , nu )
	#Else
	Dim ret As zu
	vec##na ( @ret.x , nu ,  @z1.x , nu , @z2.x , nu , @z3.x , nu )
	Return ret
	#endif
End Function
#EndIf
#EndMacro
#Macro WritFunction2para(na,nu)
Function na OverLoad ( ByVal z1 As vec##nu , ByVal z2 As vec##nu , ByVal z3 As vec##nu ) As vec##nu
	Dim ret As vec##nu
	vec##na ( @ret.x , nu ,  @z1.x , nu , @z2.x , nu , @z3.x , nu )
	Return ret
End Function
Function na OverLoad ( ByVal z1 As vec##nu , ByVal z2 As float , ByVal z3 As vec##nu ) As vec##nu
	Dim ret As vec##nu
	vec##na ( @ret.x , nu ,  @z1.x , nu , @z2 , 1 , @z3.x , nu )
	Return ret
End Function
Function na OverLoad ( ByVal z1 As vec##nu , ByVal z2 As vec##nu , ByVal z3 As float ) As vec##nu
	Dim ret As vec##nu
	vec##na ( @ret.x , nu ,  @z1.x , nu , @z2.x , nu , @z3 , 1 )
	Return ret
End Function
Function na OverLoad ( ByVal z1 As vec##nu , ByVal z2 As float , ByVal z3 As float ) As vec##nu
	Dim ret As vec##nu
	vec##na ( @ret.x , nu ,  @z1.x , nu , @z2 , 1 , @z3 , 1 )
	Return ret
End Function

#EndMacro

/'***********************************************************
########################____vec2____#########################
***********************************************************'/

Constructor vec2 ()
	x = 0
	y = 0
End Constructor
Constructor vec2 ( ByVal v1 As float, ByVal v2 As float )
	x = v1
	y = v2
End Constructor
	
Property vec2.xy () As vec2
	Return vec2( x , y )
End Property
Property vec2.xy ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
	
Property vec2.rg () As vec2
	Return vec2( x , y )
End Property
Property vec2.rg ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
	
Property vec2.st () As vec2
	Return vec2( x , y )
End Property
Property vec2.st ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
	
Operator vec2.+= ( ByVal v1 As float )
	vecsum(@x,2,@x,2,@v1,1)
End Operator
Operator vec2.+= ( ByVal v1 As vec2 )
	vecsum(@x,2,@x,2,@v1.x,2)
End Operator
	
Operator vec2.-= ( ByVal v1 As float )
	vecsub(@x,2,@x,2,@v1,1)
End Operator
Operator vec2.-= ( ByVal v1 As vec2 )
	vecsub(@x,2,@x,2,@v1.x,2)
End Operator
	
Operator vec2.*= ( ByVal v1 As float )
	vecmul(@x,2,@x,2,@v1,1)
End Operator
Operator vec2.*= ( ByVal v1 As vec2 )
	vecmul(@x,2,@x,2,@v1.x,2)
End Operator
	
Operator vec2./= ( ByVal v1 As float )
	vecdiv(@x,2,@x,2,@v1,1)
End Operator
Operator vec2./= ( ByVal v1 As vec2 )
	vecdiv(@x,2,@x,2,@v1.x,2)
End Operator
	
Operator vec2.^= ( ByVal v1 As float )
	vecpot(@x,2,@x,2,@v1,1)
End Operator
Operator vec2.^= ( ByVal v1 As vec2 )
	vecpot(@x,2,@x,2,@v1.x,2)
End Operator
	
Operator vec2.Cast () As String
	Return "{ "+Str(x)+", "+Str(y)+" }"
End Operator

InitOperator(+,2,sum)
Operator - ( ByVal v1 As vec2 ) As vec2
	Dim ret As vec2
	Dim zero As Single = 0
	vecsub ( @ret.x,2,@zero,1,@v1.x,2)
	Return ret
End Operator
InitOperator(-,2,Sub)
InitOperator(*,2,mul)
InitOperator(/,2,div)
InitOperator(^,2,pot)
InitOperator(=,2,same)
InitOperator(>,2,bigger)
InitOperator(<,2,smaler)
InitOperator(>=,2,biggersame)
InitOperator(<=,2,smalersame)
InitOperator(<>,2,notsame)

WritFunction1para(anytrue,2,Byte,1)
WritFunction1para(alltrue,2,Byte,1)

WritFunction1para(sing,2,vec2,1)
WritFunction1para(floor,2,vec2,1)
WritFunction1para(ceil,2,vec2,1)
WritFunction1para(fract,2,vec2,1)
WritFunction1para(min,2,vec2,2)
WritFunction1para(max,2,vec2,2)

WritFunction1para(length,2,float,1)
WritFunction1para(distance,2,float,2)

WritFunction1para(normalize,2,vec2,1)
WritFunction2para(clamp,2)
WritFunction1para(mix,2,vec2,3)
Function mix OverLoad ( ByVal v1 As vec2 , ByVal v2 As vec2 , ByVal v3 As float ) As vec2
	Dim ret As vec2
	vecmix(@ret.x,2,@v1.x,2,@v2.x,2,@v3,1)
	Return ret
End Function
WritFunction2para(smootstep,2)

WritFunction1para(dot,2,float,2)

WritFunction1para(sqrt,2,vec2,1)
WritFunction1para(faceforward,2,vec2,3)
WritFunction1para(reflect,2,vec2,2)

/'***********************************************************
########################____vec2____#########################
***********************************************************'/

Constructor vec3 ()
	x = 0
	y = 0
	z = 0
End Constructor
Constructor vec3 ( ByVal v1 As float, ByVal v2 As float, ByVal v3 As float )
	x = v1
	y = v2
	z = v3
End Constructor
Constructor vec3 ( ByVal v1 As vec2, ByVal v2 As float )
	x = v1.x
	y = v1.y
	z = v2
End Constructor
Constructor vec3 ( ByVal v1 As float, ByVal v2 As vec2 )
	x = v1
	y = v2.x
	z = v2.y
End Constructor
	
Property vec3.xy () As vec2
	Return vec2( x , y )
End Property
Property vec3.xy ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
Property vec3.xz () As vec2
	Return vec2( x , z )
End Property
Property vec3.xz ( ByVal v1 As vec2 )
	x = v1.x
	z = v1.y
End Property
Property vec3.yz () As vec2
	Return vec2( y , z )
End Property
Property vec3.yz ( ByVal v1 As vec2 )
	y = v1.x
	z = v1.y
End Property
Property vec3.xyz () As vec3
	Return vec3( x , y , z )
End Property
Property vec3.xyz ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	z = v1.z
End Property
	
Property vec3.rg () As vec2
	Return vec2( x , y )
End Property
Property vec3.rg ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
Property vec3.rb () As vec2
	Return vec2( x , z )
End Property
Property vec3.rb ( ByVal v1 As vec2 )
	x = v1.x
	z = v1.y
End Property
Property vec3.gb () As vec2
	Return vec2( y , z )
End Property
Property vec3.gb ( ByVal v1 As vec2 )
	y = v1.x
	z = v1.y
End Property
Property vec3.rgb () As vec3
	Return vec3( x , y , z )
End Property
Property vec3.rgb ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	z = v1.z
End Property
	
Property vec3.st () As vec2
	Return vec2( x , y )
End Property
Property vec3.st ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
Property vec3.sp () As vec2
	Return vec2( x , z )
End Property
Property vec3.sp ( ByVal v1 As vec2 )
	x = v1.x
	z = v1.y
End Property
Property vec3.tp () As vec2
	Return vec2( y , z )
End Property
Property vec3.tp ( ByVal v1 As vec2 )
	y = v1.x
	z = v1.y
End Property
Property vec3.stp () As vec3
	Return vec3( x , y , z )
End Property
Property vec3.stp ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	z = v1.z
End Property
	
Operator vec3.+= ( ByVal v1 As float )
	vecsum(@x,3,@x,3,@v1,1)
End Operator
Operator vec3.+= ( ByVal v1 As vec3 )
	vecsum(@x,3,@x,3,@v1.x,3)
End Operator
	
Operator vec3.-= ( ByVal v1 As float )
	vecsub(@x,3,@x,3,@v1,1)
End Operator
Operator vec3.-= ( ByVal v1 As vec3 )
	vecsub(@x,3,@x,3,@v1.x,3)
End Operator
	
Operator vec3.*= ( ByVal v1 As float )
	vecmul(@x,3,@x,3,@v1,1)
End Operator
Operator vec3.*= ( ByVal v1 As vec3 )
	vecmul(@x,3,@x,3,@v1.x,3)
End Operator
	
Operator vec3./= ( ByVal v1 As float )
	vecdiv(@x,3,@x,3,@v1,1)
End Operator
Operator vec3./= ( ByVal v1 As vec3 )
	vecdiv(@x,3,@x,3,@v1.x,3)
End Operator
	
Operator vec3.^= ( ByVal v1 As float )
	vecpot(@x,3,@x,3,@v1,1)
End Operator
Operator vec3.^= ( ByVal v1 As vec3 )
	vecpot(@x,3,@x,3,@v1.x,3)
End Operator
	
Operator vec3.Cast () As String
	Return "{ "+Str(x)+", "+Str(y)+", "+Str(z)+" }"
End Operator

InitOperator(+,3,sum)
Operator - ( ByVal v1 As vec3 ) As vec3
	Dim ret As vec3
	Dim zero As Single = 0
	vecsub ( @ret.x,3,@zero,1,@v1.x,3)
	Return ret
End Operator
InitOperator(-,3,Sub)
InitOperator(*,3,mul)
InitOperator(/,3,div)
InitOperator(^,3,pot)
InitOperator(=,3,same)
InitOperator(>,3,bigger)
InitOperator(<,3,smaler)
InitOperator(>=,3,biggersame)
InitOperator(<=,3,smalersame)
InitOperator(<>,3,notsame)

WritFunction1para(anytrue,3,Byte,1)
WritFunction1para(alltrue,3,Byte,1)

WritFunction1para(sing,3,vec3,1)
WritFunction1para(floor,3,vec3,1)
WritFunction1para(ceil,3,vec3,1)
WritFunction1para(fract,3,vec3,1)
WritFunction1para(min,3,vec3,2)
WritFunction1para(max,3,vec3,2)

WritFunction1para(length,3,float,1)
WritFunction1para(distance,3,float,2)

WritFunction1para(normalize,3,vec3,1)
WritFunction2para(clamp,3)
WritFunction1para(mix,3,vec3,3)
Function mix OverLoad ( ByVal v1 As vec3 , ByVal v2 As vec3 , ByVal v3 As float ) As vec3
	Dim ret As vec3
	vecmix(@ret.x,3,@v1.x,3,@v2.x,3,@v3,1)
	Return ret
End Function
WritFunction2para(smootstep,3)

WritFunction1para(dot,3,float,2)

WritFunction1para(sqrt,3,vec3,1)
WritFunction1para(faceforward,3,vec3,3)
WritFunction1para(reflect,3,vec3,2)

/'***********************************************************
########################____vec4____#########################
***********************************************************'/

Constructor vec4 ()
	x = 0
	y = 0
	z = 0
	w = 0
End Constructor
Constructor vec4 ( ByVal v1 As float, ByVal v2 As float, ByVal v3 As float, ByVal v4 As float )
	x = v1
	y = v2
	z = v3
	w = v4
End Constructor
Constructor vec4 ( ByVal v1 As vec2, ByVal v2 As float, ByVal v3 As float )
	x = v1.x
	y = v1.y
	z = v2
	w = v3
End Constructor
Constructor vec4 ( ByVal v1 As float, ByVal v2 As vec2, ByVal v3 As float )
	x = v1
	y = v2.x
	z = v2.y
	w = v3
End Constructor
Constructor vec4 ( ByVal v1 As float, ByVal v2 As float, ByVal v3 As vec2 )
	x = v1
	y = v2
	z = v3.x
	w = v3.y
End Constructor
Constructor vec4 ( ByVal v1 As vec2, ByVal v2 As vec2 )
	x = v1.x
	y = v1.y
	z = v2.x
	w = v2.y
End Constructor
Constructor vec4 ( ByVal v1 As vec3, ByVal v2 As float )
	x = v1.x
	y = v1.y
	z = v1.z
	w = v2
End Constructor
Constructor vec4 ( ByVal v1 As float, ByVal v2 As vec3 )
	x = v1
	y = v2.x
	z = v2.y
	w = v2.z
End Constructor
	
Property vec4.xy () As vec2
	 Return vec2( x , y )
End Property
Property vec4.xy ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
Property vec4.xz () As vec2
	Return vec2( x , z )
End Property
Property vec4.xz ( ByVal v1 As vec2 )
	x = v1.x
	z = v1.y
End Property
Property vec4.xw () As vec2
	Return vec2( x , w )
End Property
Property vec4.xw ( ByVal v1 As vec2 )
	x = v1.x
	w = v1.y
End Property
Property vec4.yz () As vec2
	Return vec2( y , z )
End Property
Property vec4.yz ( ByVal v1 As vec2 )
	y = v1.x
	z = v1.y
End Property
Property vec4.yw () As vec2
	Return vec2( y , w )
End Property
Property vec4.yw ( ByVal v1 As vec2 )
	y = v1.x
	w = v1.y
End Property
Property vec4.zw () As vec2
	Return vec2( z , w )
End Property
Property vec4.zw ( ByVal v1 As vec2 )
	z = v1.x
	w = v1.y
End Property
Property vec4.xyz () As vec3
	Return vec3( x , y , z )
End Property
Property vec4.xyz ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	z = v1.z
End Property
Property vec4.xyw () As vec3
	Return vec3( x , y , w )
End Property
Property vec4.xyw ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	w = v1.z
End Property
Property vec4.xzw () As vec3
	Return vec3( x , z , w )
End Property
Property vec4.xzw ( ByVal v1 As vec3 )
	x = v1.x
	z = v1.y
	w = v1.z
End Property
Property vec4.yzw () As vec3
	Return vec3( y , z , w )
End Property
Property vec4.yzw ( ByVal v1 As vec3 )
	y = v1.x
	z = v1.y
	w = v1.z
End Property
Property vec4.xyzw () As vec4
	Return vec4( x , y , z , w )
End Property
Property vec4.xyzw ( ByVal v1 As vec4 )
	x = v1.x
	y = v1.y
	z = v1.z
	w = v1.w
End Property
	
Property vec4.rg () As vec2
	 Return vec2( x , y )
End Property
Property vec4.rg ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
Property vec4.rb () As vec2
	Return vec2( x , z )
End Property
Property vec4.rb ( ByVal v1 As vec2 )
	x = v1.x
	z = v1.y
End Property
Property vec4.ra () As vec2
	Return vec2( x , w )
End Property
Property vec4.ra ( ByVal v1 As vec2 )
	x = v1.x
	w = v1.y
End Property
Property vec4.gb () As vec2
	Return vec2( y , z )
End Property
Property vec4.gb ( ByVal v1 As vec2 )
	y = v1.x
	z = v1.y
End Property
Property vec4.ga () As vec2
	Return vec2( y , w )
End Property
Property vec4.ga ( ByVal v1 As vec2 )
	y = v1.x
	w = v1.y
End Property
Property vec4.ba () As vec2
	Return vec2( z , w )
End Property
Property vec4.ba ( ByVal v1 As vec2 )
	z = v1.x
	w = v1.y
End Property
Property vec4.rgb () As vec3
	Return vec3( x , y , z )
End Property
Property vec4.rgb ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	z = v1.z
End Property
Property vec4.rga () As vec3
	Return vec3( x , y , w )
End Property
Property vec4.rga ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	w = v1.z
End Property
Property vec4.rba () As vec3
	Return vec3( x , z , w )
End Property
Property vec4.rba ( ByVal v1 As vec3 )
	x = v1.x
	z = v1.y
	w = v1.z
End Property
Property vec4.gba () As vec3
	Return vec3( y , z , w )
End Property
Property vec4.gba ( ByVal v1 As vec3 )
	y = v1.x
	z = v1.y
	w = v1.z
End Property
Property vec4.rgba () As vec4
	Return vec4( x , y , z , w )
End Property
Property vec4.rgba ( ByVal v1 As vec4 )
	x = v1.x
	y = v1.y
	z = v1.z
	w = v1.w
End Property
	
Property vec4.st () As vec2
	 Return vec2( x , y )
End Property
Property vec4.st ( ByVal v1 As vec2 )
	x = v1.x
	y = v1.y
End Property
Property vec4.sp () As vec2
	Return vec2( x , z )
End Property
Property vec4.sp ( ByVal v1 As vec2 )
	x = v1.x
	z = v1.y
End Property
Property vec4.sq () As vec2
	Return vec2( x , w )
End Property
Property vec4.sq ( ByVal v1 As vec2 )
	x = v1.x
	w = v1.y
End Property
Property vec4.tp () As vec2
	Return vec2( y , z )
End Property
Property vec4.tp ( ByVal v1 As vec2 )
	y = v1.x
	z = v1.y
End Property
Property vec4.tq () As vec2
	Return vec2( y , w )
End Property
Property vec4.tq ( ByVal v1 As vec2 )
	y = v1.x
	w = v1.y
End Property
Property vec4.pq () As vec2
	Return vec2( z , w )
End Property
Property vec4.pq ( ByVal v1 As vec2 )
	z = v1.x
	w = v1.y
End Property
Property vec4.stp () As vec3
	Return vec3( x , y , z )
End Property
Property vec4.stp ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	z = v1.z
End Property
Property vec4.stq () As vec3
	Return vec3( x , y , w )
End Property
Property vec4.stq ( ByVal v1 As vec3 )
	x = v1.x
	y = v1.y
	w = v1.z
End Property
Property vec4.spq () As vec3
	Return vec3( x , z , w )
End Property
Property vec4.spq ( ByVal v1 As vec3 )
	x = v1.x
	z = v1.y
	w = v1.z
End Property
Property vec4.tpq () As vec3
	Return vec3( y , z , w )
End Property
Property vec4.tpq ( ByVal v1 As vec3 )
	y = v1.x
	z = v1.y
	w = v1.z
End Property
Property vec4.stpq () As vec4
	Return vec4( x , y , z , w )
End Property
Property vec4.stpq ( ByVal v1 As vec4 )
	x = v1.x
	y = v1.y
	z = v1.z
	w = v1.w
End Property
	
Operator vec4.+= ( ByVal v1 As float )
	vecsum(@x,4,@x,4,@v1,1)
End Operator
Operator vec4.+= ( ByVal v1 As vec4 )
	vecsum(@x,4,@x,4,@v1.x,4)
End Operator
	
Operator vec4.-= ( ByVal v1 As float )
	vecsub(@x,4,@x,4,@v1,1)
End Operator
Operator vec4.-= ( ByVal v1 As vec4 )
	vecsub(@x,4,@x,4,@v1.x,4)
End Operator
	
Operator vec4.*= ( ByVal v1 As float )
	vecmul(@x,4,@x,4,@v1,1)
End Operator
Operator vec4.*= ( ByVal v1 As vec4 )
	vecmul(@x,4,@x,4,@v1.x,4)
End Operator
	
Operator vec4./= ( ByVal v1 As float )
	vecdiv(@x,4,@x,4,@v1,1)
End Operator
Operator vec4./= ( ByVal v1 As vec4 )
	vecdiv(@x,4,@x,4,@v1.x,4)
End Operator
	
Operator vec4.^= ( ByVal v1 As float )
	vecpot(@x,4,@x,4,@v1,1)
End Operator
Operator vec4.^= ( ByVal v1 As vec4 )
	vecpot(@x,4,@x,4,@v1.x,4)
End Operator
	
Operator vec4.Cast () As String
	Return "{ "+Str(x)+", "+Str(y)+", "+Str(z)+", "+Str(w)+" }"
End Operator

InitOperator(+,4,sum)
Operator - ( ByVal v1 As vec4 ) As vec4
	Dim ret As vec4
	Dim zero As Single = 0
	vecsub ( @ret.x,4,@zero,1,@v1.x,4)
	Return ret
End Operator
InitOperator(-,4,Sub)
InitOperator(*,4,mul)
InitOperator(/,4,div)
InitOperator(^,4,pot)
InitOperator(=,4,same)
InitOperator(>,4,bigger)
InitOperator(<,4,smaler)
InitOperator(>=,4,biggersame)
InitOperator(<=,4,smalersame)
InitOperator(<>,4,notsame)

WritFunction1para(anytrue,4,Byte,1)
WritFunction1para(alltrue,4,Byte,1)

WritFunction1para(sing,4,vec4,1)
WritFunction1para(floor,4,vec4,1)
WritFunction1para(ceil,4,vec4,1)
WritFunction1para(fract,4,vec4,1)
WritFunction1para(min,4,vec4,2)
WritFunction1para(max,4,vec4,2)

WritFunction1para(length,4,float,1)
WritFunction1para(distance,4,float,2)

WritFunction1para(normalize,4,vec4,1)
WritFunction2para(clamp,4)
WritFunction1para(mix,4,vec4,3)
Function mix OverLoad ( ByVal v1 As vec4 , ByVal v2 As vec4 , ByVal v3 As float ) As vec4
	Dim ret As vec4
	vecmix(@ret.x,4,@v1.x,4,@v2.x,4,@v3,1)
	Return ret
End Function
WritFunction2para(smootstep,4)

WritFunction1para(dot,4,float,2)

WritFunction1para(sqrt,4,vec4,1)
WritFunction1para(faceforward,4,vec4,3)
WritFunction1para(reflect,4,vec4,2)

#Undef InitOperator
#Undef WritFunction1para
#Undef WritFunction2para
