Const GameName = "MidiPlayer"
#Include "MidiPlayer.bi"

Config = LoadXML ( "Config.epc" )

If Config.ItemS ( "LogFile" ) = "" Then End

InitLog ( Config.ItemS ( "LogFile" ) )
WriteLog ( "======== Start "+GameName+" ========" )

Sub SetAllCheckBoxesChecked(ByVal hWin As HWND)
	CheckDlgButton(hWin,CHANNEL1_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL2_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL3_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL4_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL5_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL6_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL7_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL8_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL9_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL10_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL11_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL12_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL13_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL14_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL15_CHK,BST_CHECKED)
	CheckDlgButton(hWin,CHANNEL16_CHK,BST_CHECKED)
End Sub
Sub SetAllCheckBoxes(ByVal hWin As HWND, ByVal channel As UInteger)
	If (channel And 1)=0 Then 
		CheckDlgButton(hWin,CHANNEL1_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL1_CHK,BST_CHECKED)
	EndIf
	If (channel And 2)=0 Then 
		CheckDlgButton(hWin,CHANNEL2_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL2_CHK,BST_CHECKED)
	EndIf
	If (channel And 4)=0 Then 
		CheckDlgButton(hWin,CHANNEL3_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL3_CHK,BST_CHECKED)
	EndIf
	If (channel And 8)=0 Then 
		CheckDlgButton(hWin,CHANNEL4_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL4_CHK,BST_CHECKED)
	EndIf
	If (channel And 16)=0 Then 
		CheckDlgButton(hWin,CHANNEL5_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL5_CHK,BST_CHECKED)
	EndIf
	If (channel And 32)=0 Then 
		CheckDlgButton(hWin,CHANNEL6_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL6_CHK,BST_CHECKED)
	EndIf
	If (channel And 64)=0 Then 
		CheckDlgButton(hWin,CHANNEL7_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL7_CHK,BST_CHECKED)
	EndIf
	If (channel And 128)=0 Then 
		CheckDlgButton(hWin,CHANNEL8_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL8_CHK,BST_CHECKED)
	EndIf
	If (channel And 256)=0 Then 
		CheckDlgButton(hWin,CHANNEL9_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL9_CHK,BST_CHECKED)
	EndIf
	If (channel And 512)=0 Then 
		CheckDlgButton(hWin,CHANNEL10_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL10_CHK,BST_CHECKED)
	EndIf
	If (channel And 1024)=0 Then 
		CheckDlgButton(hWin,CHANNEL11_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL11_CHK,BST_CHECKED)
	EndIf
	If (channel And 2048)=0 Then 
		CheckDlgButton(hWin,CHANNEL12_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL12_CHK,BST_CHECKED)
	EndIf
	If (channel And 4096)=0 Then 
		CheckDlgButton(hWin,CHANNEL13_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL13_CHK,BST_CHECKED)
	EndIf
	If (channel And 8192)=0 Then 
		CheckDlgButton(hWin,CHANNEL14_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL14_CHK,BST_CHECKED)
	EndIf
	If (channel And 16384)=0 Then 
		CheckDlgButton(hWin,CHANNEL15_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL15_CHK,BST_CHECKED)
	EndIf
	If (channel And 32768)=0 Then 
		CheckDlgButton(hWin,CHANNEL16_CHK,BST_UNCHECKED)
	Else
		CheckDlgButton(hWin,CHANNEL16_CHK,BST_CHECKED)
	EndIf
End Sub
Function CalcChannel(ByVal hWin As HWND)As UInteger
	Dim As UInteger channel
	If IsDlgButtonChecked(hWin,CHANNEL1_CHK) Then channel Or=1
	If IsDlgButtonChecked(hWin,CHANNEL2_CHK) Then channel Or=2
	If IsDlgButtonChecked(hWin,CHANNEL3_CHK) Then channel Or=4
	If IsDlgButtonChecked(hWin,CHANNEL4_CHK) Then channel Or=8
	If IsDlgButtonChecked(hWin,CHANNEL5_CHK) Then channel Or=16 
	If IsDlgButtonChecked(hWin,CHANNEL6_CHK) Then channel Or=32
	If IsDlgButtonChecked(hWin,CHANNEL7_CHK) Then channel Or=64
	If IsDlgButtonChecked(hWin,CHANNEL8_CHK) Then channel Or=128
	If IsDlgButtonChecked(hWin,CHANNEL9_CHK) Then channel Or=256
	If IsDlgButtonChecked(hWin,CHANNEL10_CHK) Then channel Or=512
	If IsDlgButtonChecked(hWin,CHANNEL11_CHK) Then channel Or=1024
	If IsDlgButtonChecked(hWin,CHANNEL12_CHK) Then channel Or=2048
	If IsDlgButtonChecked(hWin,CHANNEL13_CHK) Then channel Or=4096
	If IsDlgButtonChecked(hWin,CHANNEL14_CHK) Then channel Or=8192
	If IsDlgButtonChecked(hWin,CHANNEL15_CHK) Then channel Or=16384
	If IsDlgButtonChecked(hWin,CHANNEL16_CHK) Then channel Or=32768
	Return channel
End Function

Function TIMER_PROC(ByVal hWin As HWND, ByVal uMsg as UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	SendDlgItemMessage(hWin,MUSIC_TRB,TBM_SETPOS,TRUE,OpenedMusic->getPos()*257)
	Return TRUE
End Function

Function MAIN_WIN_PROC(ByVal hWin As HWND, ByVal uMsg as UINT, ByVal wParam As WPARAM, ByVal lParam As LPARAM) As Integer
	Dim WinRect As RECT
	Select Case uMsg
		Case WM_INITDIALOG
			
			MUSIC.Init( Config.ItemS("SoundFont") )
			OpenedMusic = MUSIC.create()
			
			SetAllCheckBoxesChecked(hWin)
			SetDlgItemInt(hWin,TXT_CHANNEL,CalcChannel(hWin),FALSE)
			
			SendMessage (hWin, WM_SETICON, ICON_SMALL, Cast(LPARAM,LoadIcon(hInstance,MAKEINTRESOURCE(FB_PROGRAM_ICON))) )
			
			SendDlgItemMessage(hWin,MUSIC_TRB,TBM_SETRANGEMAX,TRUE,255*257)
			SetTimer(hWin,200,10,Cast(Any Ptr,@TIMER_PROC))
			
		Case WM_CLOSE
			
			If OpenedMusic Then OpenedMusic->destroy()
			MUSIC.Quit( )

			DestroyWindow(hWin)
			
		Case WM_COMMAND
			Select Case LoWord(wParam)
				Case IDM_OPEN
					Dim N As String
					N = OpenFFile( hWin, "Midi (*.mid) "& szNULL & "*.mid" & szNULL, "Open Music" )
					If N <> "" Then
						If InStr(N,".") = 0 Then N += ".mid"
						OpenedMusic->load(N,TRUE)
						OpenedMusic->play()
						Dim channel As UInteger
						channel = CalcChannel(hWin)
						For i As Integer = 0 To 15
							If (channel And (2 Shl i)) Then
								OpenedMusic->setChannelVol(i,1)
							Else
								OpenedMusic->setChannelVol(i,0)
							EndIf
						Next
						OpenedMusic->update()
						
					EndIf
				Case IDM_EXIT
					SendMessage(hWin,WM_CLOSE,0,0)
				
				Case CHANNEL1_CHK, CHANNEL2_CHK, CHANNEL3_CHK, CHANNEL4_CHK,_
					CHANNEL5_CHK, CHANNEL6_CHK, CHANNEL7_CHK, CHANNEL8_CHK,_
					CHANNEL9_CHK, CHANNEL10_CHK, CHANNEL11_CHK, CHANNEL12_CHK,_
					CHANNEL13_CHK, CHANNEL14_CHK, CHANNEL15_CHK, CHANNEL16_CHK
					
					Dim channel As UInteger
					channel = CalcChannel(hWin)
					For i As Integer = 0 To 15
						If (channel And (2 Shl i)) Then
							OpenedMusic->setChannelVol(i,1)
						Else
							OpenedMusic->setChannelVol(i,0)
						EndIf
					Next
					SetDlgItemInt(hWin,TXT_CHANNEL,channel,FALSE)
					OpenedMusic->update()
					
				Case TXT_CHANNEL
					Dim channel As UInteger
					channel = GetDlgItemInt(hWin,TXT_CHANNEL,NULL,FALSE)
					SetAllCheckBoxes(hWin,channel)
					For i As Integer = 0 To 15
						If (channel And (2 Shl i)) Then
							OpenedMusic->setChannelVol(i,1)
						Else
							OpenedMusic->setChannelVol(i,0)
						EndIf
					Next
					OpenedMusic->update()
					
			End Select
		Case WM_HSCROLL
			Dim As Long _pos
			_pos = SendDlgItemMessage(hWin,MUSIC_TRB,TBM_GETPOS,0,0)
			OpenedMusic->setPos(_pos/257)
		Case else
			Return FALSE
			
	End Select
	Return TRUE

End Function


DialogBoxParam(hInstance,Cast(zstring ptr,MAIN_WIN),NULL,@MAIN_WIN_PROC,NULL)

WriteLog ( "========= End "+GameName+" =========" )
