'*******************************************************************************
'
' DETECTION ECHEC
'
'*******************************************************************************

declare sub CalculEchec (oc() as byte,_
                          tr   as byte,_
                    byref es   as ubyte,_
                    byref gr   as ubyte,_
                    byref pr   as ubyte)
                    
declare sub CalculEchecCourt (oc() as byte,_
                               tr   as byte,_
                         byref es   as ubyte)
                          
'*******************************************************************************

sub CalculEchec (oc() as byte,_
                  tr   as byte,_
            byref es   as ubyte,_
            byref gr   as ubyte,_
            byref pr   as ubyte)
                  
  dim as byte x1, y1, x2, y2
  
  es=Faux' Eschec
  gr=Vrai' Grand roque
  pr=Vrai' Petit roque
  
  for x1=1 to 8
    for y1=1 to 8
      
      if not (sgn(oc(x1,y1))=-1*tr) then continue for
      if (abs(oc(x1,y1))=1) and (x2=x1) then continue for
      if abs(oc(x1,y1))=6 then continue for
      
      for x2=1 to 8
        for y2=1 to 8
          
          if oc(x2,y2)=6*tr then
            if MouvementNaturel(x1,y1,x2,y2,oc())=Vrai then es=Vrai
          end if
          
          if ((tr=Blanc) andalso (y2=1)) or ((tr=Noir) andalso (y2=8)) then
            if MouvementNaturel(x1,y1,x2,y2,oc())=Vrai then
              if x2<6 then gr=Faux
              if x2>4 then pr=Faux
            end if
          end if
          
        next y2
      next x2
      
    next y1
  next x1

end sub

'*******************************************************************************

sub CalculEchecCourt (oc() as byte,_
                       tr   as byte,_
                 byref es   as ubyte)
                  
  dim as byte x1, y1, x2, y2
  
  es=Faux' Eschec
  
  for x1=1 to 8
    for y1=1 to 8
      
      if not (sgn(oc(x1,y1))=-1*tr) then continue for
      if (abs(oc(x1,y1))=1) and (x2=x1) then continue for
      if abs(oc(x1,y1))=6 then continue for
      
      for x2=1 to 8
        for y2=1 to 8
          
          if oc(x2,y2)=6*tr then
            if MouvementNaturel(x1,y1,x2,y2,oc())=Vrai then es=Vrai
          end if
          
        next y2
      next x2
      
    next y1
  next x1

end sub

'*******************************************************************************