'*******************************************************************************
'
' EVALUATION
'
'*******************************************************************************

declare sub Evaluation (liste as string, byref meilleur as string)
declare sub Machine (mlr as string, byref comm as string)

'*******************************************************************************

const UsageLivre=Vrai

'*******************************************************************************

sub Evaluation (liste as string, byref meilleur as string)
  
  if len(liste)=0 then
    meilleur="exit"
    exit sub
  end if
  
  if UsageLivre=Vrai then
    ReadBook(meilleur)
    if not (meilleur="----") then exit sub
  end if
  
  dim as ubyte i,j,k
  dim as string coup0,coup1,coup2
  dim as byte x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6
  
  dim as single note (1 to len(liste)\4), noteMax=-1000
  
  dim as ubyte ArriveeExposee,ArriveeCouverte,Couverture()
  dim as ubyte EchecInstant1, MatInstant2, MoinsDe3PossibInstant2
  dim as byte PireBalanceInstant2
  dim as byte x, y, dx, dy
  
  dim as ubyte ff=freefile
  dim as integer defaut=open("Trace.txt" for output as #ff)
  
  for i=1 to len(liste)\4
    
    coup0=mid(liste,1+4*(i-1),4)
    
    if defaut=0 then print #ff,coup0+"********"
    
    x1=coup0[0]-96
    y1=coup0[1]-48
    x2=coup0[2]-96
    y2=coup0[3]-48
    
    note(i)=Instant1(i).balance*Trait
    
    if abs(Occupant(x2,y2))>abs(Occupant(x1,y1)) then note(i)+=10
    
    if Instant1(i).n=0 then
      note(i)+=100
      CalculEchecCourt (Instant1(i).valeur(),-1*Trait,EchecInstant1)
      if EchecInstant1=Vrai then note(i)+=1
    end if
    
    select case as const abs(Occupant(x1,y1))
    
    case Pion
      for dx=-1 to 1 step 2
        for dy=-1 to 1 step 2
          if Occupant(x2+dx,y2+dy)=Pion*Trait then note(i)+=1/10
          if Occupant(x1+dx,y1+dy)=Pion*Trait then note(i)-=1/10
        next dy
      next dx
      note(i)-=abs(x2-9/2)/10
      
    case Cavalier
      note(i)-=abs(x2-9/2)/10
      
    case Fou
      
    case Tour
      note(i)-=1
    case Dame
      note(i)-=1
    case Roi
      note(i)-=3
      if abs(x2-x1)=2 then note(i)+=3
      
    end select
    
    ArriveeExposee=Faux
    
    ArriveeCouverte=Faux
    redim Couverture(1 to len(Instant1(i).liste)\4)
    
    PireBalanceInstant2=100
    
    MatInstant2=Faux
    MoinsDe3PossibInstant2=Faux
    
    if (defaut=0) andalso (len(Instant1(i).liste)\4=0) then
      print #ff,"Possibles=0"
    end if
    
    for j=1 to len(Instant1(i).liste)\4
      
      coup1=mid(Instant1(i).liste,1+4*(j-1),4)
      
      if defaut=0 then print #ff,coup0+coup1+"****"
      
      x3=coup1[0]-96
      y3=coup1[1]-48
      x4=coup1[2]-96
      y4=coup1[3]-48
      
      if (x4=x2) andalso (y4=y2) then ArriveeExposee=Vrai
      
      if ( Instant2(i,j).balance*Trait < PireBalanceInstant2 ) then
        PireBalanceInstant2 = Instant2(i,j).balance*Trait
      end if
      
      if ( Instant2(i,j).n = 0 ) then
        MatInstant2=Vrai
      end if
      
      if ( Instant2(i,j).n < 3 ) then
        MoinsDe3PossibInstant2=Vrai
      end if
      
      Couverture(j)=Faux
      
      if (defaut=0) andalso (len(Instant2(i,j).liste)\4=0) then
        print #ff,"Possibles=0"
      end if
      
      for k=1 to len(Instant2(i,j).liste)\4
        
        coup2=mid(Instant2(i,j).liste,1+4*(k-1),4)
        
        x5=coup2[0]-96
        y5=coup2[1]-48
        x6=coup2[2]-96
        y6=coup2[3]-48
        
        if (x6=x2) andalso (y6=y2) then Couverture(j)=Vrai
        
        if defaut=0 then print #ff,coup0+coup1+coup2
        
      next k
      
      if Couverture(j)=Vrai then ArriveeCouverte=Vrai
      
    next j
    
    if (ArriveeExposee=Faux) then note(i)+=abs(Occupant(x2,y2))
    if (ArriveeExposee=Vrai) then note(i)-=abs(Occupant(x1,y1))
      
    if (ArriveeExposee=Vrai) and (ArriveeCouverte=Faux) then
      note(i)+=abs(Occupant(x2,y2))-abs(Occupant(x1,y1))
    end if
    
    note(i)+=PireBalanceInstant2
    
    if MatInstant2=Vrai then note(i)-=100
    if MoinsDe3PossibInstant2=Vrai then note(i)-=3
    
    select case as const abs(Occupant(x1,y1))
    
    case Pion
      
    case Cavalier
      if ArriveeExposee=Faux then
        for x=1 to 8
          for y=1 to 8
            if (x-x2)*(x-x2)+(y-y2)*(y-y2)=5 then
              if sgn(Occupant(x,y))=-1*Trait then
                note(i)+=abs(Occupant(x,y))
              end if
            end if
          next y
        next x
      end if
      
    case Fou
      if ArriveeExposee=Faux then
        for x=1 to 8
          for y=1 to 8
            if (x-x2)=(y-y2) then
              if sgn(Occupant(x,y))=-1*Trait then
                note(i)+=abs(Occupant(x,y))/2
              end if
            end if
          next y
        next x
      end if
     
    case Tour
      
    case Dame
      
    case Roi
      
    end select
    
    if note(i)>noteMax then noteMax=note(i)
    
  next i
  
  for i=1 to len(liste)\4
    
    if note(i)=noteMax then
      
      meilleur=mid(liste,1+4*(i-1),4)
      exit sub
      
    end if
    
  next i
  
  if defaut=0 then close #ff
  
end sub

'*******************************************************************************

sub Machine (mlr as string, byref comm as string)
  comm=mlr
end sub

'*******************************************************************************