'*******************************************************************************
'
' FICHIERS
'
'*******************************************************************************

declare sub EnregistrePosition
declare function LastPosition as ubyte
declare sub EnregistrePartie

'*******************************************************************************

sub EnregistrePosition
  dim as ubyte ff=freefile
  dim defaut as integer
  
  defaut=open("Position.txt" for output as #ff)
  
  if defaut=0 then

    print #ff,FEN
    close #ff
  else
    
  end if
end sub

'*******************************************************************************

function LastPosition as ubyte
  dim as ubyte ff=freefile
  dim as integer defaut
  dim ligne as string
  
  defaut=open("Position.txt" for input as #ff)
  if defaut=0 then
    
    line input #ff,ligne
    close #ff
    InitFromStringFEN(ligne)
    return Vrai
  else
    return Faux
  end if
end function

'*******************************************************************************

sub EnregistrePartie
  
  dim as ubyte ff=freefile
  dim defaut as integer
  
  defaut=open("Partie.txt" for output as #ff)
  
  if defaut=0 then
    
    print #ff,"Eschecs"+chr(32);
    print #ff,mid(date,4,2)+"/"+left(date,2)+"/"+right(date,4)+chr(32);
    print #ff,left(time,5)
    
    select case ModeJeu
    case 1
      print #ff,"Blanc: Utilisateur"
      print #ff,"Noir: Ordinateur"
    case 2
      print #ff,"Blanc: Ordinateur"
      print #ff,"Noir: Utilisateur"
    case 3
      print #ff,"Blanc: Utilisateur"
      print #ff,"Noir: Utilisateur"
    end select
    
    for i as short=1 to len(Partie)\4
      if not(i/2=i\2) then
        print #ff,mid(Partie,1+4*(i-1),4);
      else
        print #ff,chr(32)+mid(Partie,1+4*(i-1),4)
      end if
    next i
    
    close #ff
    
  else
    
  end if
end sub

'*******************************************************************************