'*******************************************************************************
'
' PROGRAMME PRINCIPAL
'
'*******************************************************************************

dim Commande as string
dim ListePossibles as string
dim NombrePossibles as ubyte
dim as ubyte NPmax1, NPmax2
dim MeilleurCoup as string

'*******************************************************************************

CopieImages("Pieces.txt")

if LastPosition=Faux then
  Initialise
else
  Partie="********"
end if

OuvreFenetre
DessineTablier
DessineBoutons
AffCoordonnees

do
  
  sleep 50
  Notifications(0)
  
  if (Trait=Blanc) then
    CalculEchec (Occupant(), Trait, Eschec, Secundo(e1c1), Secundo(e1g1))
  else
    CalculEchec (Occupant(), Trait, Eschec, Secundo(e8c8), Secundo(e8g8))
  end if
  
  CalculPossibles (Occupant(),_
                   Trait,_
                   Primo(),_
                   Secundo(),_
                   CarreauPassant,_
                   ListePossibles,_
                   NombrePossibles)
  
  AucunCoupPossible=Iif(NombrePossibles=0,Vrai,Faux)
  
  Notifications(1)
  
  if (ModeJeu=Trait) or ((ModeJeu=2) and (Trait=Noir)) or (ModeJeu=3) then
    Notifications(2)
    Utilisateur (ListePossibles,Commande)
  else
    redim as TPosition Instant1 (1 to NombrePossibles)
    Prevision1 (Occupant(), Trait, ListePossibles, NombrePossibles, NPmax1)
    redim as TPosition Instant2 (1 to NombrePossibles,1 to NPmax1)
    Prevision2 (Instant1(), Trait, NombrePossibles, NPmax1, NPmax2)
    Evaluation (ListePossibles, MeilleurCoup)
    Notifications (2)
    Machine (MeilleurCoup, Commande)
    if (Commande="exit") then
      Utilisateur (ListePossibles, Commande)
    end if
  end if
  
  AfficheCoup("efface")
  
  if not (Commande="init") then
    Mouvement (Commande)
    ReDessineTablier
    Partie+=Commande
  else
    Initialise
    DessineTablier
  end if
  
loop until (Commande="exit")

EnregistrePosition
EnregistrePartie

end

'*******************************************************************************