'BlendFade.bas - Game207 pixel fade blender
'Ryan Kelly (codeFoil) 2012

'==========================================================================|

#Include "Common.bi"

'==========================================================================|

public _
Function  BlendFade(byval src as Colour_Value,_
                    byval dst as Colour_Value,_
                    byval lvl as any ptr      ) as Colour_Value

    If src = COLOUR_TRANSPARENT  Then 
        function = COLOUR_TRANSPARENT
    Else

        Dim  as Integer srcR = (src And &h00FF0000 ) Shr 16,_
                        srcG = (src And &h0000FF00 ) Shr  8,_
                        srcB = (src And &h000000FF ) 

        Dim  as Integer ptr level = Cast(Integer ptr, lvl)
        Dim  as Double factor = *level / 255

        function = RGBA(srcR * factor, srcG * factor, srcB * factor, &hFF )

    End  if

End  function