'Debug.bi - Game 207 Debugging Macros
'Ryan R. Kelly (codeFoil) 2012

'===DEBUG=MACROS===========================================================|

#IfDef DEBUG

#Define DPRINT(_m_) DebugPrint  (_m_)
Declare  sub DebugPrint(byref message as String )

#Macro DASSERT(_c_,_m_)
    If  Not (_c_)  Then
        DPRINT(__FUNCTION__)
        DPRINT((_m_))
        Sleep
        End -1
    End if
#EndMacro

#Define DPAUSE DPRINT("Debug Pause") : Sleep

#Else

#Define DPRINT(_m_)
#Define DASSERT(_c_,_m_)
#Define DPAUSE

#Endif
