'Text_Message.bi - Game207 Text Message Control

'==========================================================================|

'Included by GUI.bi
'Include order must be preserved.

#IfnDef  GAME207_GUI
#Include once "Common.bi"
#Include once "Bounding_Box.bi"
#Include once "Layout.bi"
#EndIf

'===TEXT=MESSAGE===========================================================|

Type  Text_Message

  Public:

    as Bounding_Box box

  '------------------------------------------------------------------------|

    Declare  constructor(byval initMessage as String      ,_
                         byval initFc      as Colour_Value,_
                         byval initBc      as Colour_Value,_
                         byval initTc      as Colour_Value )

    Declare  sub Draw(byval dest as Image_Buffer )

    Declare  sub SetText(byref newMessage as String )

  '------------------------------------------------------------------------|

    Declare  function Show()      as Boolean
    Declare  function Hide()      as Boolean
    Declare  property isVisible() as Boolean

  '------------------------------------------------------------------------|

  Private:
    as Boolean visibleFlag = FALSE
  
    as String  message
    as Colour_Value fillC   ,_
                    boarderC,_
                    textC

  '------------------------------------------------------------------------|

    Declare  sub AdjustSize()   

  '------------------------------------------------------------------------|

End  type
